global _RV_IntersectBoundingBox0
global _RV_SIMD_TrLst0
global _RV_TraceList0
global _RV_TraceList1
global _CheckSSE
global _RV_MData
global _RV_Data

extern _Cmin
extern _cframe
extern _Ambient
extern _cray
extern _OrgOb
extern _CLtOb
extern _RV_Lights
extern _bckdrp

extern _BBcandidatePlane
extern _BBlastframe
extern _BBquadrant
extern _BBinside
extern _BBMin
extern _BBMax

extern _RV_DispatchIntersectOther0
extern _RV_DispatchIntersectOther1

segment _DATA

align 4

fzero:        dd 000000000h ;  0.0000
fsmall:       dd 038d1b717h ;  0.0001
fonehalf:     dd 03F000000h ;  0.5000
fone:         dd 03F800000h ;  1.0000
fminus1:      dd 0BF800000h ; -1.0000

segment .bss

alignb 16
              resd 4  ; padding
_RV_Data:

Camera:       resd 4  ; 00h camera coordinates

Ray:          resd 4  ; 10h normal ray direction

CInt:         resd 4  ; 20h intersection point
              resd 4  ; 30h normal vector at intersection point
              resd 2  ; 40h surface parameters u,v
              resd 2  ; 48h texture coordinates x,y
              resd 1  ; 50h ray parameter t
              resd 1  ; 54h pointer to intersected primitive
              resw 1  ; 58h face index for cube

              resw 1  ; 5Ah 
              resd 1  ; 5Ch shadow feeler length

RayOrg:       resd 4  ; 60h ray origin
RayDir:       resd 4  ; 70h ray direction
tmpors        resd 6  ; 80h
              resd 2  ; 98h
                      ; A0h

_RV_MData:    resd 4  ;  00h/  0 1 * camera x,y,z,w
              resd 4  ;  10h/  4 4 * org .x
              resd 4  ;  20h/  8 4 * org .y
              resd 4  ;  30h/ 12 4 * org .z
              resd 4  ;  40h/ 16 4 * ray .x
              resd 4  ;  50h/ 20 4 * ray .y
              resd 4  ;  60h/ 24 4 * ray .z
MCInt:        resd 4  ;  70h/ 28 4 * current intersection parameter t
              resd 4  ;  80h/ 32 4 * current intersection point IP.x
              resd 4  ;  90h/ 36 4 * current intersection point IP.y
              resd 4  ;  A0h/ 40 4 * current intersection point IP.z
              resd 4  ;  B0h/ 44 4 * current intersection parameter u
              resd 4  ;  C0h/ 48 4 * current intersection parameter v

MCMin:        resd 4  ;  D0h/ 52 4 * minimum intersection parameter t
              resd 4  ;  E0h/ 56 4 * object of minimum t
              resd 4  ;  F0h/ 60 4 * minimum intersection point IP.x
              resd 4  ; 100h/ 64 4 * minimum intersection point IP.y
              resd 4  ; 110h/ 68 4 * minimum intersection point IP.z
              resd 4  ; 120h/ 72 4 * minimum intersection normal N.x
              resd 4  ; 130h/ 76 4 * minimum intersection normal N.y
              resd 4  ; 140h/ 80 4 * minimum intersection normal N.z

RCol:         resd 4  ; 150h/ 84 4 * color.R
              resd 4  ; 160h/ 88 4 * color.G
              resd 4  ; 170h/ 92 4 * color.B

Shfd:         resd 4  ; 180h/ 96 4 * shadow feeler direction .x
              resd 4  ; 190h/100 4 * shadow feeler direction .y
              resd 4  ; 200h/104 4 * shadow feeler direction .z
              resd 4  ; 210h/108 4 * shadow feeler maximum intersection parameters
              resd 4  ; 220h/112 4 * temp value storage
              resd 4  ; 230h/116 4 * temp shadow storage

segment _CODE

SSIPN:    ; intersection point IP = Camera + t * Ray;
          movss   XMM1, [ecx+0D0h]
          movss   XMM4, [ecx+040h]
          mulss   XMM4, XMM1
          addss   XMM4, [eax     ]
          movss   [ecx+0F0h], XMM4
          movss   XMM5, [ecx+050h]
          mulss   XMM5, XMM1
          addss   XMM5, [eax+004h]
          movss   [ecx+100h], XMM5
          movss   XMM6, [ecx+060h]
          mulss   XMM6, XMM1
          addss   XMM6, [eax+008h]
          movss   [ecx+110h], XMM6
          ; intersection normal N  = unit(IP - SimpleSphere->position);
          subss   XMM4, [ebx+010h]
          subss   XMM5, [ebx+014h]
          subss   XMM6, [ebx+018h]
          movss   XMM0, XMM4
          mulss   XMM0, XMM0
          movss   XMM1, XMM5
          mulss   XMM1, XMM1
          movss   XMM2, XMM6
          mulss   XMM2, XMM2
          addss   XMM0, XMM1
          addss   XMM0, XMM2
          sqrtss  XMM0, XMM0
          divss   XMM4, XMM0
          movss   [ecx+120h],XMM4
          divss   XMM5, XMM0
          movss   [ecx+130h],XMM5
          divss   XMM6, XMM0
          movss   [ecx+140h],XMM6
          ret

GetIPN:   mov     ebx,dword [eax+0E0h]  ; object 1
          mov     cx,word [ebx]         ; dispatch type
          test    cx,0FFFEh             ; Triangle or Parallelogram
          jnz     .oth11
          mov     ecx,dword [ebx+034h]  ; copy N.x
          mov     dword [eax+120h],ecx
          mov     ecx,dword [ebx+038h]  ; copy N.y
          mov     dword [eax+130h],ecx
          mov     ecx,dword [ebx+03Ch]  ; copy N.z
          mov     dword [eax+140h],ecx
          jmp     .cont1
.oth11:   cmp     cx,2                  ; SimpleSphere
          jne     .oth12
          mov     ecx,eax
          call    SSIPN
          jmp     .cont1
.oth12:
.cont1:   mov     ebx,dword [eax+0E4h]  ; object 2
          mov     cx,word [ebx]         ; dispatch type
          test    cx,0FFFEh             ; Triangle or Parallelogram
          jnz     .oth21
          mov     ecx,dword [ebx+034h]  ; copy N.x
          mov     dword [eax+124h],ecx
          mov     ecx,dword [ebx+038h]  ; copy N.y
          mov     dword [eax+134h],ecx
          mov     ecx,dword [ebx+03Ch]  ; copy N.z
          mov     dword [eax+144h],ecx
          jmp     .cont2
.oth21:   cmp     cx,2                  ; SimpleSphere
          jne     .oth22
          lea     ecx,  [eax+004h]
          call    SSIPN
          jmp     .cont2
.oth22:
.cont2:   mov     ebx,dword [eax+0E8h]  ; object 2
          mov     cx,word [ebx]         ; dispatch type
          test    cx,0FFFEh             ; Triangle or Parallelogram
          jnz     .oth31
          mov     ecx,dword [ebx+034h]  ; copy N.x
          mov     dword [eax+128h],ecx
          mov     ecx,dword [ebx+038h]  ; copy N.y
          mov     dword [eax+138h],ecx
          mov     ecx,dword [ebx+03Ch]  ; copy N.z
          mov     dword [eax+148h],ecx
          jmp     .cont3
.oth31:   cmp     cx,2                  ; SimpleSphere
          jne     .oth32
          lea     ecx,  [eax+008h]
          call    SSIPN
          jmp     .cont3
.oth32:
.cont3:   mov     ebx,dword [eax+0ECh]  ; object 2
          mov     cx,word [ebx]         ; dispatch type
          test    cx,0FFFEh             ; Triangle or Parallelogram
          jnz     .oth41
          mov     ecx,dword [ebx+034h]  ; copy N.x
          mov     dword [eax+12Ch],ecx
          mov     ecx,dword [ebx+038h]  ; copy N.y
          mov     dword [eax+13Ch],ecx
          mov     ecx,dword [ebx+03Ch]  ; copy N.z
          mov     dword [eax+14Ch],ecx
          jmp     .cont4
.oth41:   cmp     cx,2                  ; SimpleSphere
          jne     .oth42
          lea     ecx,  [eax+00Ch]
          call    SSIPN
          jmp     .cont4
.oth42:
.cont4:   ret


_CheckSSE:push   ebp
          mov    ebp,esp
          push   ebx
          ; first check if CPUID-command is available
          pushfd                 ; copy EFlags-register
          pop    eax             ; to eax
          mov    ebx,eax         ; and to ebx
          xor    eax,00200000h   ; change bit 21
          push   eax             ; copy eax
          popfd                  ; to EFlags-register
          pushfd                 ; and back
          pop    eax             ; to eax
          xor    eax,ebx         ; compare with ebx
          jz     .NoSSE
          ; use CPUID to check for SSE
          mov    eax,1
          cpuid
          test   edx,02000000h
          jz     .NoSSE
          mov    eax,1
          jmp    .exit
.NoSSE:   mov    eax,0
.exit:    pop    ebx
          leave
          ret

NormShade:
          movaps   XMM5,[eax+0D0h]
          movss    XMM6,[fzero   ]
          pshufd   XMM7,XMM6,0
          cmpps    XMM7,XMM5,1
          movmskps edx,XMM7
          and      dl,15
          ; skip shader calculation if none of the 4 rays hit anything
          jz       near .skip
          call     GetIPN
          movss    XMM3,[fone    ]
          pshufd   XMM4,XMM3,0
          movaps   XMM0,[eax+120h]
          addps    XMM0,XMM4
          movaps   XMM1,[eax+130h]
          addps    XMM1,XMM4
          movaps   XMM2,[eax+140h]
          addps    XMM2,XMM4
          movss    XMM3,[fonehalf]
          pshufd   XMM4,XMM3,0
          mulps    XMM0,XMM4
          mulps    XMM1,XMM4
          mulps    XMM2,XMM4
          movaps   [eax+150h],XMM0
          movaps   [eax+160h],XMM1
          movaps   [eax+170h],XMM2
          cmp      dl,15
          je       near .nxt4
          movss    XMM6,[fzero   ]
          test     dl,1
          jnz      .nxt1
          movss    [eax+150h],XMM6
          movss    [eax+160h],XMM6
          movss    [eax+170h],XMM6
.nxt1:    test     dl,2
          jnz      .nxt2
          movss    [eax+154h],XMM6
          movss    [eax+164h],XMM6
          movss    [eax+174h],XMM6
.nxt2:    test     dl,4
          jnz      .nxt3
          movss    [eax+158h],XMM6
          movss    [eax+168h],XMM6
          movss    [eax+178h],XMM6
.nxt3:    test     dl,8
          jnz      .nxt4
          movss    [eax+15Ch],XMM6
          movss    [eax+16Ch],XMM6
          movss    [eax+17Ch],XMM6
.nxt4:    ret
.skip:    movaps   [eax+150h],XMM6
          movaps   [eax+160h],XMM6
          movaps   [eax+170h],XMM6
          ret

;RGB_Color ShadeSimple(vector *Org, vector *Ray, IntPar IntP, MatPtr mat, int level)
;{
;  GetIPN(Org, Ray, &IntP);
;  vector L = unit(RV_Lights->p - IntP.IP);
;  float  s = (IntP.p->flags & RV_ReceiveNoShadow)? 1.0f : 1.0f-ShadowTest(IntP.p, RV_Lights->Prim, &(IntP.IP), &L, distance(RV_Lights->p, IntP.IP));
;  float NL = s*(L % IntP.N); if(NL<0.0f) NL=0.0f;
;  RGB_Color C; C.R = (Ambient.R + NL) * IntP.p->Mat->Reflection.R;
;               C.G = (Ambient.G + NL) * IntP.p->Mat->Reflection.G;
;               C.B = (Ambient.B + NL) * IntP.p->Mat->Reflection.B;
;  return C;
;}

SimpleShade:
          movaps   XMM5,[eax+0D0h]
          movss    XMM6,[fzero   ]
          pshufd   XMM7,XMM6,0
          cmpps    XMM7,XMM5,1
          movmskps edx,XMM7
          and      dl,15
          ; skip shader calculation if none of the 4 rays hits anything
          jz       near .skip
          call    GetIPN
          ; vector L = unit(RV_Lights->p - CMin.IP);
          mov     ebx, [_RV_Lights]
          movss   XMM3,[ebx+008h]
          pshufd  XMM0,XMM3,0
          subps   XMM0,[eax+0F0h]
          movss   XMM4,[ebx+00Ch]
          pshufd  XMM1,XMM4,0
          subps   XMM1,[eax+100h]
          movss   XMM3,[ebx+010h]
          pshufd  XMM2,XMM3,0
          subps   XMM2,[eax+110h]
          movaps  XMM4,XMM0
          mulps   XMM0,XMM0
          movaps  XMM5,XMM1
          mulps   XMM1,XMM1
          movaps  XMM6,XMM2
          mulps   XMM2,XMM2
          addps   XMM0,XMM1
          addps   XMM0,XMM2
          sqrtps  XMM0,XMM0
          divps   XMM4,XMM0
          movaps  [eax+180h],XMM4
          divps   XMM5,XMM0
          movaps  [eax+190h],XMM5
          divps   XMM6,XMM0
          movaps  [eax+200h],XMM6
          ; XMM4 = L % IntP.N
          mulps   XMM4,[eax+120h]
          mulps   XMM5,[eax+130h]
          mulps   XMM6,[eax+140h]
          addps   XMM4,XMM5
          addps   XMM4,XMM6
          ; if(XMM4<0.0f) XMM4=0.0f
          movss    XMM6,[fzero   ]
          pshufd   XMM7,XMM6,0
          maxps    XMM4,XMM7

          ; check where primitive has RECEIVE_NO_SHADOW flag
          movss    XMM0,[fzero]
          movss    XMM7,[fone ]
          mov      bx,0
          pshufd   XMM0,XMM0,0
          mov      ecx, dword [eax+0E4h] ; CMin.p
          mov      cx,   word [ecx+002h] ; CMin.p->flags
          and      cx,800h
          jz       .w1
          movss    XMM0,XMM7
          inc      bx
.w1:      pshufd   XMM0,XMM0,57
          mov      ecx, dword [eax+0E8h] ; CMin.p
          mov      cx,   word [ecx+002h] ; CMin.p->flags
          and      cx,800h
          jz       .w2
          movss    XMM0,XMM7
          inc      bx
.w2:      pshufd   XMM0,XMM0,57
          mov      ecx, dword [eax+0ECh] ; CMin.p
          mov      cx,   word [ecx+002h] ; CMin.p->flags
          and      cx,800h
          jz       .w3
          movss    XMM0,XMM7
          inc      bx
.w3:      pshufd   XMM0,XMM0,57
          mov      ecx, dword [eax+0E0h] ; CMin.p
          mov      cx,   word [ecx+002h] ; CMin.p->flags
          and      cx,800h
          jz       .w4
          movss    XMM0,XMM7
          inc      bx
.w4:      movaps   [eax+230h],XMM0
          cmp      bx,4
          je       .skpshd

          movaps   [eax+220h],XMM4
          mov      ebx,[ebp+8]
          call     RV_SIMD_TrLstS

          movaps   XMM4,[eax+220h]
          movaps   XMM7,[eax+210h]
          orps     XMM7,[eax+230h]
          mulps    XMM4,XMM7

.skpshd:  mov      ecx, dword [eax+0E4h] ; CMin.p
          mov      ecx, dword [ecx+008h] ; CMin.p->Mat
          movss    XMM5,[ecx+020h] ; CMin.p->Mat->Reflection.R
          movss    XMM0,XMM5
          movss    XMM6,[ecx+024h] ; CMin.p->Mat->Reflection.G
          movss    XMM1,XMM6
          movss    XMM7,[ecx+028h] ; CMin.p->Mat->Reflection.B
          movss    XMM2,XMM7
.skp1:    pshufd   XMM0,XMM0,57
          pshufd   XMM1,XMM1,57
          pshufd   XMM2,XMM2,57
          mov      ecx, dword [eax+0E8h] ; CMin.p
          mov      ecx, dword [ecx+008h] ; CMin.p->Mat
          movss    XMM5,[ecx+020h] ; CMin.p->Mat->Reflection.R
          movss    XMM0,XMM5
          movss    XMM6,[ecx+024h] ; CMin.p->Mat->Reflection.G
          movss    XMM1,XMM6
          movss    XMM7,[ecx+028h] ; CMin.p->Mat->Reflection.B
          movss    XMM2,XMM7
.skp2:    pshufd   XMM0,XMM0,57
          pshufd   XMM1,XMM1,57
          pshufd   XMM2,XMM2,57
          mov      ecx, dword [eax+0ECh] ; CMin.p
          mov      ecx, dword [ecx+008h] ; CMin.p->Mat
          movss    XMM5,[ecx+020h] ; CMin.p->Mat->Reflection.R
          movss    XMM0,XMM5
          movss    XMM6,[ecx+024h] ; CMin.p->Mat->Reflection.G
          movss    XMM1,XMM6
          movss    XMM7,[ecx+028h] ; CMin.p->Mat->Reflection.B
          movss    XMM2,XMM7
.skp3:    pshufd   XMM0,XMM0,57
          pshufd   XMM1,XMM1,57
          pshufd   XMM2,XMM2,57
          mov      ecx, dword [eax+0E0h] ; CMin.p
          mov      ecx, dword [ecx+008h] ; CMin.p->Mat
          movss    XMM5,[ecx+020h] ; CMin.p->Mat->Reflection.R
          movss    XMM0,XMM5
          movss    XMM6,[ecx+024h] ; CMin.p->Mat->Reflection.G
          movss    XMM1,XMM6
          movss    XMM7,[ecx+028h] ; CMin.p->Mat->Reflection.B
          movss    XMM2,XMM7
.skp4:    
          movss    XMM6,[_Ambient    ]
          pshufd   XMM5,XMM6,0
          addps    XMM5,XMM4
          mulps    XMM0,XMM5
          movaps   [eax+150h],XMM0
          movss    XMM6,[_Ambient+04h]
          pshufd   XMM5,XMM6,0
          addps    XMM5,XMM4
          mulps    XMM1,XMM5
          movaps   [eax+160h],XMM1
          movss    XMM6,[_Ambient+08h]
          pshufd   XMM5,XMM6,0
          addps    XMM5,XMM4
          mulps    XMM2,XMM5
          movaps   [eax+170h],XMM2

          ;cmp      dl,15
          ;je       near .nxt4
          ;movss    XMM6,[fzero   ]
          ;test     dl,1
          ;jnz      .nxt1
          ;movss    [eax+150h],XMM6
          ;movss    [eax+160h],XMM6
          ;movss    [eax+170h],XMM6
.nxt1:    ;test     dl,2
          ;jnz      .nxt2
          ;movss    [eax+154h],XMM6
          ;movss    [eax+164h],XMM6
          ;movss    [eax+174h],XMM6
.nxt2:    ;test     dl,4
          ;jnz      .nxt3
          ;movss    [eax+158h],XMM6
          ;movss    [eax+168h],XMM6
          ;movss    [eax+178h],XMM6
.nxt3:    ;test     dl,8
          ;jnz      .nxt4
          ;movss    [eax+15Ch],XMM6
          ;movss    [eax+16Ch],XMM6
          ;movss    [eax+17Ch],XMM6
.nxt4:    ret
.skip:    movaps   [eax+150h],XMM6
          movaps   [eax+160h],XMM6
          movaps   [eax+170h],XMM6
          ret

_RV_IntersectBoundingBox0:
          push   ebp
          mov    ebp,esp
          push   eax
          push   ebx
          push   ecx
          mov    eax,_RV_Data     ; pointer to camera and ray vectors
          and    eax,0FFFFFFF0h   ; align to 16 byte

          ; is precalculation already done for this frame?
          mov    cx,word [_cframe]       ; current frame
          cmp    cx,word [_BBlastframe]  ; = last precalculated frame?
          je     near .samefrm           ; then skip precalculation
          mov    word [_BBlastframe],cx  ; else store current frame number and precalculate:

          ; Find candidate planes
          mov    word [_BBinside],1
          mov    bx,2
          movss  XMM0,[eax]
          comiss XMM0,[_BBMin]
          jnc    .p1
          mov    ecx, dword [_BBMin]
          mov    bx,1
          jmp    .f1
.p1:      comiss XMM0,[_BBMax]
          jc     .p2
          mov    ecx, dword [_BBMax]
          mov    bx,0
.f1:      mov    dword [_BBcandidatePlane],ecx
          mov    word [_BBinside],0
.p2:      mov    word [_BBquadrant],bx

          mov    bx,2
          movss  XMM0,[eax+4]
          comiss XMM0,[_BBMin+4]
          jnc    .p3
          mov    ecx, dword [_BBMin+4]
          mov    bx,1
          jmp    .f2
.p3:      comiss XMM0,[_BBMax+4]
          jc     .p4
          mov    ecx, dword [_BBMax+4]
          mov    bx,0
.f2:      mov    dword [_BBcandidatePlane+4],ecx
          mov    word [_BBinside],0
.p4:      mov    word [_BBquadrant+2],bx

          mov    bx,2
          movss  XMM0,[eax+8]
          comiss XMM0,[_BBMin+8]
          jnc    .p5
          mov    ecx, dword [_BBMin+8]
          mov    bx,1
          jmp    .f3
.p5:      comiss XMM0,[_BBMax+8]
          jc     .p6
          mov    ecx, dword [_BBMax+8]
          mov    bx,0
.f3:      mov    dword [_BBcandidatePlane+8],ecx
          mov    word [_BBinside],0
.p6:      mov    word [_BBquadrant+4],bx

.samefrm: ; exit if camera is inside bounding box
          test   word [_BBinside], 0FFFFh
          jnz    near .inside
          
          ; calculate distances to candidate planes
          movss  XMM1,[fminus1]
          mov    bx, word [_BBquadrant  ]
          cmp    bx,2
          je     .s1
          movss  XMM1,[_BBcandidatePlane  ]
          subss  XMM1,[eax    ]
          divss  XMM1,[eax+10h]
.s1:      movss  XMM2,[fminus1]
          mov    bx, word [_BBquadrant+2]
          cmp    bx,2
          je     .s2
          movss  XMM2,[_BBcandidatePlane+4]
          subss  XMM2,[eax+04h]
          divss  XMM2,[eax+14h]
.s2:      movss  XMM3,[fminus1]
          mov    bx, word [_BBquadrant+4]
          cmp    bx,2
          je     .s3
          movss  XMM3,[_BBcandidatePlane+8]
          subss  XMM3,[eax+08h]
          divss  XMM3,[eax+18h]
.s3:      
          ; get largest of the maxT's for final choice of intersection
          mov    bx,0
          comiss XMM1,XMM2
          jnc    .c1
          mov    bx,1
          movss  XMM1,XMM2
.c1:      comiss XMM1,XMM3
          jnc    .c2
          mov    bx,2
          movss  XMM1,XMM3
.c2:      movss  [eax+50h],XMM1

          ; exit if t is negative (intersection is behind camera)
          comiss XMM1,[fzero  ]
          jc     near .NoHit

          cmp    bx,0
          je     .skip1
          ; intersection point IP.x = Camera.x + t * Ray.x
          movss  XMM0,[eax+10h]
          mulss  XMM0,XMM1
          addss  XMM0,[eax    ]
          movss  [eax+20h],XMM0
          ; exit if point is outside box
          comiss XMM0,[_BBMin  ]
          jc     near .NoHit
          comiss XMM0,[_BBMax  ]
          jnc    near .NoHit
          jmp    .cont1
.skip1:   mov    ecx, dword [_BBcandidatePlane  ]
          mov    [eax+20h],ecx
.cont1:   cmp    bx,1
          je     .skip2
          ; intersection point IP.y = Camera.y + t * Ray.y
          movss  XMM0,[eax+14h]
          mulss  XMM0,XMM1
          addss  XMM0,[eax+04h]
          movss  [eax+24h],XMM0
          ; exit if point is outside box
          comiss XMM0,[_BBMin+4]
          jc     near .NoHit
          comiss XMM0,[_BBMax+4]
          jnc    near .NoHit
          jmp    .cont2
.skip2:   mov    ecx, dword [_BBcandidatePlane+4]
          mov    [eax+24h],ecx
.cont2:   cmp    bx,2
          je     .skip3
          ; intersection point IP.z = Camera.z + t * Ray.z
          movss  XMM0,[eax+18h]
          mulss  XMM0,XMM1
          addss  XMM0,[eax+08h]
          movss  [eax+28h],XMM0
          ; exit if point is outside box
          comiss XMM0,[_BBMin+8]
          jc     .NoHit
          comiss XMM0,[_BBMax+8]
          jnc    .NoHit
          jmp    .cont3
.skip3:   mov    ecx, dword [_BBcandidatePlane+8]
          mov    [eax+28h],ecx
.cont3:   pop    ecx
          pop    ebx
          pop    eax
          leave
          ret
.NoHit:   ;exit with negative return value
          mov    dword [eax+50h],0BF800000h
          pop    ecx
          pop    ebx
          pop    eax
          leave
          ret
.inside:  mov    ebx,[eax  ]
          mov    [eax+20h],ebx
          mov    ecx,[eax+4]
          mov    [eax+24h],ecx
          mov    edx,[eax+8]
          mov    [eax+28h],edx
          mov    dword [eax+50h],03F800000h
          pop    ecx
          pop    ebx
          pop    eax
          leave
          ret

SortCubePlanes:
          ; XMM0 = or[0]/(Ray.x*Axis1.x + Ray.y*Axis1.y + Ray.z*Axis1.z)
          movss  XMM1,[edx+028h]  ;  Axis1.x
          mulss  XMM1,XMM5        ; *Ray.x
          movss  XMM2,[edx+02Ch]  ;  Axis1,y
          mulss  XMM2,XMM6        ; *Ray.y
          addss  XMM1,XMM2        ; +
          movss  XMM2,[edx+030h]  ;  Axis1.z
          mulss  XMM2,XMM7        ; *Ray.z
          addss  XMM1,XMM2        ; +
          movss  XMM0,[ebx+000h]  ;  or[0]
          divss  XMM0,XMM1        ; /(Ray*Axis1)

          ; XMM1 = or[1]/(Ray.x*-Axis1.x + Ray.y*-Axis1.y + Ray.z*-Axis1.z)
          movss  XMM2,[edx+028h]  ;  Axis1.x
          mulss  XMM2,[fminus1]   ; *-1
          mulss  XMM2,XMM5        ; *Ray.x
          movss  XMM3,[edx+02Ch]  ;  Axis1,y
          mulss  XMM3,XMM6        ; *Ray.y
          subss  XMM2,XMM3        ; +-
          movss  XMM3,[edx+030h]  ;  Axis1.z
          mulss  XMM3,XMM7        ; *Ray.z
          subss  XMM2,XMM3        ; +-
          movss  XMM1,[ebx+004h]  ;  or[1]
          divss  XMM1,XMM2        ; /(Ray*-Axis1)

          ; XMM2 = or[2]/(Ray.x*Axis2.x + Ray.y*Axis2.y + Ray.z*Axis2.z)
          movss  XMM3,[edx+034h]  ;  Axis2.x
          mulss  XMM3,XMM5        ; *Ray.x
          movss  XMM4,[edx+038h]  ;  Axis2,y
          mulss  XMM4,XMM6        ; *Ray.y
          addss  XMM3,XMM4        ; +
          movss  XMM4,[edx+03Ch]  ;  Axis2.z
          mulss  XMM4,XMM7        ; *Ray.z
          addss  XMM3,XMM4        ; +
          movss  XMM2,[ebx+008h]  ;  or[2]
          divss  XMM2,XMM3        ; /(Ray*Axis2)

          ; XMM3 = or[3]/(Ray.x*-Axis2.x + Ray.y*-Axis2.y + Ray.z*-Axis2.z)
          movss  XMM4,[edx+034h]  ;  Axis2.x
          mulss  XMM4,[fminus1]   ; *-1
          mulss  XMM4,XMM5        ; *Ray.x
          movss  XMM3,[edx+038h]  ;  Axis2,y
          mulss  XMM3,XMM6        ; *Ray.y
          subss  XMM4,XMM3        ; +-
          movss  XMM3,[edx+03Ch]  ;  Axis2.z
          mulss  XMM3,XMM7        ; *Ray.z
          subss  XMM4,XMM3        ; +-
          movss  XMM3,[ebx+00Ch]  ;  or[3]
          divss  XMM3,XMM4        ; /(Ray*-Axis2)

          ; XMM4 = or[4]/(Ray.x*Axis3.x + Ray.y*Axis3.y + Ray.z*Axis3.z)
          mulss  XMM5,[edx+040h]  ; Ray.x*Axis3.x
          movss  XMM4,[edx+044h]  ;  Axis3,y
          mulss  XMM4,XMM6        ; *Ray.y
          addss  XMM5,XMM4        ; +
          movss  XMM4,[edx+048h]  ;  Axis3.z
          mulss  XMM4,XMM7        ; *Ray.z
          addss  XMM5,XMM4        ; +
          movss  XMM4,[ebx+010h]  ;  or[4]
          divss  XMM4,XMM5        ; /(Ray*Axis3)

          ; XMM5 = or[5]/(Ray.x*-Axis3.x + Ray.y*-Axis3.y + Ray.z*-Axis3.z)
          movss  XMM5,[edx+040h]  ;  Axis3.x
          mulss  XMM5,[ecx]       ; *Ray.x
          mulss  XMM6,[edx+044h]  ; Ray.y*Axis3,y
          mulss  XMM6,[fminus1]   ; *-1
          subss  XMM6,XMM5        ; +-
          mulss  XMM7,[edx+048h]  ; Ray.z*Axis3.z
          subss  XMM6,XMM7        ; +-
          movss  XMM5,[ebx+014h]  ;  or[5]
          divss  XMM5,XMM6        ; /(Ray*-Axis3)

          ; sort near and far planes in XMM-registers, ch,bl,bh holding face number of near plane

          ; sort XMM0 < XMM1 (x plane)
          mov    ch,0
          comiss XMM0,XMM1
          jc     .cnt1
          movss  XMM7,XMM0
          mov    ch,1
          movss  XMM0,XMM1
          movss  XMM1,XMM7
.cnt1:    ; sort XMM2 < XMM3 (y plane)
          mov    bl,2
          comiss XMM2,XMM3
          jc     .cnt2
          movss  XMM7,XMM2
          mov    bl,3
          movss  XMM2,XMM3
          movss  XMM3,XMM7
.cnt2:    ; sort XMM4 < XMM5 (z plane)
          mov    bh,4
          comiss XMM4,XMM5
          jc     .cnt3
          movss  XMM7,XMM4
          mov    bh,5
          movss  XMM4,XMM5
          movss  XMM5,XMM7

.cnt3:    mov    cl,ch
          ; XMM0 = max(XMM0,XMM2,XMM4), cl = number of farest near-plane
          comiss XMM0,XMM2
          jnc    .cnt4
          movss  XMM0,XMM2
          mov    cl,bl
.cnt4:    comiss XMM0,XMM4
          jnc    .cnt5
          movss  XMM0,XMM4
          mov    cl,bh
.cnt5:    ret

CalcCubeOrs:
          ; or[0] = (Top -Camera)* Axis1
          ; or[1] = (Base-Camera)*-Axis1
          movss  XMM0,[edx+01Ch]  ;  Top.x
          movss  XMM2,[edx+010h]  ;  Base.x
          movss  XMM1,[edx+020h]  ;  Top.y
          movss  XMM3,[edx+014h]  ;  Base.y
          subss  XMM2,XMM5        ; -Camera.x
          subss  XMM0,XMM5        ; -Camera.x
          subss  XMM1,XMM6        ; -Camera.y
          subss  XMM3,XMM6        ; -Camera.y
          mulss  XMM2,[edx+028h]  ; *Axis1.x
          mulss  XMM0,[edx+028h]  ; *Axis1.x
          mulss  XMM1,[edx+02Ch]  ; *Axis1.y
          mulss  XMM2,[fminus1]   ; *-1
          mulss  XMM3,[edx+02Ch]  ; *Axis1.y
          addss  XMM0,XMM1        ; +
          subss  XMM2,XMM3        ; -
          movss  XMM1,[edx+024h]  ;  Top.z
          movss  XMM3,[edx+018h]  ;  Base.z
          subss  XMM1,XMM7        ; -Camera.z
          subss  XMM3,XMM7        ; -Camera.z
          mulss  XMM1,[edx+030h]  ; *Axis1.z
          mulss  XMM3,[edx+030h]  ; *Axis1.z
          addss  XMM0,XMM1        ; +
          subss  XMM2,XMM3        ; -
          movss  [ebx     ],XMM0  ; store or[0]
          movss  [ebx+004h],XMM2  ; store or[1]

          ; or[2] = (Top -Camera)* Axis2
          ; or[3] = (Base-Camera)*-Axis2
          movss  XMM0,[edx+01Ch]  ;  Top.x
          movss  XMM2,[edx+010h]  ;  Base.x
          movss  XMM1,[edx+020h]  ;  Top.y
          movss  XMM3,[edx+014h]  ;  Base.y
          subss  XMM2,XMM5        ; -Camera.x
          subss  XMM0,XMM5        ; -Camera.x
          subss  XMM1,XMM6        ; -Camera.y
          subss  XMM3,XMM6        ; -Camera.y
          mulss  XMM2,[edx+034h]  ; *Axis2.x
          mulss  XMM0,[edx+034h]  ; *Axis2.x
          mulss  XMM1,[edx+038h]  ; *Axis2.y
          mulss  XMM2,[fminus1]   ; *-1
          mulss  XMM3,[edx+038h]  ; *Axis2.y
          addss  XMM0,XMM1        ; +
          subss  XMM2,XMM3        ; -
          movss  XMM1,[edx+024h]  ;  Top.z
          movss  XMM3,[edx+018h]  ;  Base.z
          subss  XMM1,XMM7        ; -Camera.z
          subss  XMM3,XMM7        ; -Camera.z
          mulss  XMM1,[edx+03Ch]  ; *Axis2.z
          mulss  XMM3,[edx+03Ch]  ; *Axis2.z
          addss  XMM0,XMM1        ; +
          subss  XMM2,XMM3        ; -
          movss  [ebx+008h],XMM0  ; store or[2]
          movss  [ebx+00Ch],XMM2  ; store or[3]

          ; or[4] = (Top -Camera)* Axis3
          ; or[5] = (Base-Camera)*-Axis3
          movss  XMM0,[edx+01Ch]  ;  Top.x
          movss  XMM2,[edx+010h]  ;  Base.x
          movss  XMM1,[edx+020h]  ;  Top.y
          movss  XMM3,[edx+014h]  ;  Base.y
          subss  XMM2,XMM5        ; -Camera.x
          subss  XMM0,XMM5        ; -Camera.x
          subss  XMM1,XMM6        ; -Camera.y
          subss  XMM3,XMM6        ; -Camera.y
          mulss  XMM2,[edx+040h]  ; *Axis3.x
          mulss  XMM0,[edx+040h]  ; *Axis3.x
          mulss  XMM1,[edx+044h]  ; *Axis3.y
          mulss  XMM2,[fminus1]   ; *-1
          mulss  XMM3,[edx+044h]  ; *Axis3.y
          addss  XMM0,XMM1        ; +
          subss  XMM2,XMM3        ; -
          movss  XMM1,[edx+024h]  ;  Top.z
          movss  XMM3,[edx+018h]  ;  Base.z
          subss  XMM1,XMM7        ; -Camera.z
          subss  XMM3,XMM7        ; -Camera.z
          mulss  XMM1,[edx+048h]  ; *Axis3.z
          mulss  XMM3,[edx+048h]  ; *Axis3.z
          addss  XMM0,XMM1        ; +
          subss  XMM2,XMM3        ; -
          movss  [ebx+010h],XMM0  ; store or[4]
          movss  [ebx+014h],XMM2  ; store or[5]

          ret

IntersectCube0:
          lea    ebx, [edx+4Ch]
          ; is precalculation already done for this frame?
          mov    cx,word [_cframe]    ; current frame
          cmp    cx,word [edx+0Ch]    ; = last precalculated frame?
          je     near .samefrm        ; then skip precalculation
          mov    word [edx+0Ch],cx    ; else store current frame number and precalculate:

          movss  XMM5,[eax+00h]   ;  Camera.x
          movss  XMM6,[eax+04h]   ;  Camera.y
          movss  XMM7,[eax+08h]   ;  Camera.z
          
          call   CalcCubeOrs

.samefrm: movss  XMM5,[eax+10h]   ;  Ray.x
          movss  XMM6,[eax+14h]   ;  Ray.y
          movss  XMM7,[eax+18h]   ;  Ray.z

          lea    ecx, [eax+10h]
          call   SortCubePlanes

          ; check farest near plane XMM0 is nearer nearest far plane
          comiss XMM0,XMM1
          jnc    .NoHit
          comiss XMM0,XMM3
          jnc    .NoHit
          comiss XMM0,XMM5
          jnc    .NoHit

          movss  [eax+50h],XMM0      ; store plane intersection parameter
          movsx  cx,cl
          mov    word [eax+058h],cx  ; and face number
          ret

.NoHit:   ;exit with negative return value
          mov    dword [eax+50h],0BF800000h
          ret

IntersectCube1:
          movss  XMM5,[eax+60h]   ;  Org.x
          movss  XMM6,[eax+64h]   ;  Org.y
          movss  XMM7,[eax+68h]   ;  Org.z
          
          lea    ebx, [eax+80h]
          call   CalcCubeOrs

          movss  XMM5,[eax+70h]   ;  Dir.x
          movss  XMM6,[eax+74h]   ;  Dir.y
          movss  XMM7,[eax+78h]   ;  Dir.z

          lea    ecx, [eax+70h]
          call   SortCubePlanes

          ; check farest near plane XMM0 is nearer nearest far-plane
          comiss XMM0,XMM1
          jnc    .NoHit
          comiss XMM0,XMM3
          jnc    .NoHit
          comiss XMM0,XMM5
          jnc    .NoHit

          comiss XMM0,[fsmall]
          jnc    .w1

          ; XMM1 = min(XMM1,XMM3,XMM5), cl = number of nearest far-plane
          mov    cl,ch
          comiss XMM1,XMM3
          jc     .cnt4
          movss  XMM1,XMM3
          mov    cl,bl
.cnt4:    comiss XMM1,XMM5
          jc     .cnt5
          movss  XMM1,XMM5
          mov    cl,bh
.cnt5:    xor    cl,1
          movss  [eax+50h],XMM1      ; store plane intersection parameter
          movsx  cx,cl
          mov    word [eax+058h],cx  ; and face number
          ret

.w1:      movss  [eax+50h],XMM0      ; store plane intersection parameter
          movsx  cx,cl
          mov    word [eax+058h],cx  ; and face number
          ret

.NoHit:   ;exit with negative return value
          mov    dword [eax+50h],0BF800000h
          ret


IntersectSimpleSphere0:
          ; is precalculation already done for this frame?
          mov    bx,word [_cframe]    ; current frame
          cmp    bx,word [edx+0Ch]    ; = last precalculated frame?
          je     .samefrm             ; then skip precalculation
          mov    word [edx+0Ch],bx    ; else store current frame number and precalculate:
          ; pvec  = Camera - position;
          ; cterm = pvec.x*pvec.x + pvec.y*pvec.y + pvec.z*pvec.z - r2;
          fld    dword [eax    ]
          fsub   dword [edx+10h]
          fst    dword [edx+1Ch]
          fmul   st0
          fld    dword [eax+04h]
          fsub   dword [edx+14h]
          fst    dword [edx+20h]
          fmul   st0
          fld    dword [eax+08h]
          fsub   dword [edx+18h]
          fst    dword [edx+24h]
          fmul   st0
          faddp  st1,st0
          faddp  st1,st0
          fsub   dword [edx+28h]
          fstp   dword [edx+2Ch]
.samefrm: movss   XMM0,[eax+10h]
          mulss   XMM0,[edx+1Ch]
          movss   XMM1,[eax+14h]
          mulss   XMM1,[edx+20h]
          addss   XMM0,XMM1
          movss   XMM2,[eax+18h]
          mulss   XMM2,[edx+24h]
          addss   XMM0,XMM2
          movss   XMM1,XMM0
          mulss   XMM0,XMM0
          subss   XMM0,[edx+2Ch]
          comiss  XMM0,[fzero  ]
          jc      .NoHit
          mulss   XMM1,[fminus1]
          sqrtss  XMM0,XMM0
          subss   XMM1,XMM0
          movss   [eax+50h],XMM1
          ret
.NoHit:   mov     dword [eax+50h], 0BF800000h
          ret

IntersectSimpleSphere1:
          ; XMM 0,1,2 = Org - position;
          ; XMM4 = sqr(XMM0)+sqr(XMM1)+sqr(XMM2) - r2;
          movss   XMM4,[eax+60h]
          subss   XMM4,[edx+10h]
          movss   XMM0,XMM4
          movss   XMM5,[eax+64h]
          subss   XMM5,[edx+14h]
          movss   XMM1,XMM5
          mulss   XMM4,XMM4
          movss   XMM6,[eax+68h]
          subss   XMM6,[edx+18h]
          movss   XMM2,XMM6
          mulss   XMM5,XMM5
          mulss   XMM6,XMM6
          addss   XMM4,XMM5
          subss   XMM4,[edx+28h]
          addss   XMM4,XMM6 
          ; XMM1 = Ray.x * tmpvec1.x + Ray.y * tmpvec1.y + Ray.z * tmpvec1.z
          movss   XMM3,[eax+70h]
          mulss   XMM3,XMM0
          movss   XMM5,[eax+74h]
          mulss   XMM5,XMM1
          addss   XMM3,XMM5
          movss   XMM6,[eax+78h]
          mulss   XMM6,XMM2
          addss   XMM3,XMM6
          movss   XMM1,XMM3
          ; XMM3 = XMM1*XMM1 - XMM4
          mulss   XMM3,XMM3
          subss   XMM3,XMM4
          ; return negative if XMM3<0 (Ray missing Sphere)
          comiss  XMM3,[fzero  ]
          jc      .NoHit
          ; XMM0  = -XMM1 + sqrt(XMM3)
          ; XMM1  = -XMM1 - sqrt(XMM3)
          mulss   XMM1,[fminus1]
          sqrtss  XMM3,XMM3
          movss   XMM0,XMM1
          subss   XMM1,XMM3
          addss   XMM0,XMM3
          ; return smaller XMM, where XMM is not too small
          comiss  XMM0,XMM1
          jnc     .ct
          comiss  XMM0,[fsmall]
          jc      .s1
.s0:      movss   [eax+50h],XMM0
          ret
.ct:      comiss  XMM1,[fsmall]
          jc      .s0
.s1:      movss   [eax+50h],XMM1
          ret
.NoHit:   mov     dword [eax+50h], 0BF800000h
          ret

SIMD_Int_SSphere0:
          ; is precalculation already done for this frame?
          mov     bx,word [_cframe]    ; current frame
          cmp     bx,word [edx+0Ch]    ; = last precalculated frame?
          je      .samefrm             ; then skip precalculation
          mov     word [edx+0Ch],bx    ; else store current frame number and precalculate:
          ; pvec  = Camera - position;
          ; cterm = pvec.x*pvec.x + pvec.y*pvec.y + pvec.z*pvec.z - r2;
          movss   XMM4,[eax    ]
          subss   XMM4,[edx+10h]
          movss   [edx+1Ch],XMM4
          movss   XMM5,[eax+04h]
          subss   XMM5,[edx+14h]
          movss   [edx+20h],XMM5
          mulss   XMM4,XMM4
          movss   XMM6,[eax+08h]
          subss   XMM6,[edx+18h]
          movss   [edx+24h],XMM6
          mulss   XMM5,XMM5
          mulss   XMM6,XMM6
          addss   XMM4,XMM5
          subss   XMM4,[edx+28h]
          addss   XMM4,XMM6
          movss   [edx+2Ch],XMM4 
.samefrm: ; b = Ray.x * pvec.x + Ray.y * pvec.y + Ray.z * pvec.z
          movss   XMM1,[edx+1Ch]
          pshufd  XMM0,XMM1,0
          mulps   XMM0,[eax+40h]
          movss   XMM3,[edx+20h]
          pshufd  XMM2,XMM3,0
          mulps   XMM2,[eax+50h]
          movss   XMM5,[edx+24h]
          pshufd  XMM4,XMM5,0
          mulps   XMM4,[eax+60h]
          addps   XMM0,XMM2
          addps   XMM0,XMM4
          ; d = b*b-cterm
          movaps  XMM1,XMM0
          mulps   XMM0,XMM0
          movss   XMM5,[edx+2Ch]
          pshufd  XMM4,XMM5,0
          subps   XMM0,XMM4
          ; return negative if d<0 (Ray missing Sphere)
          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM0,1
          movmskps ebx,XMM7
          test    bx,15
          jz      .NoHit
          ; t = 0 - b - sqrt(d)
          sqrtps  XMM0,XMM0
          pshufd  XMM3,XMM6,0
          subps   XMM3,XMM1
          subps   XMM3,XMM0
          movaps  [eax+70h],XMM3
          ret
.NoHit:   movss   XMM2,[fminus1]
          pshufd  XMM3,XMM2,0
          movaps  [eax+70h],XMM3
          ret

SIMD_Int_SSphereS:
          ; pvec = Cmin.IP - position;
          ; XMM4 = pvec.x*pvec.x + pvec.y*pvec.y + pvec.z*pvec.z - r2;
          movaps  XMM4,[eax+0F0h]
          movss   XMM0,[edx+ 10h]
          pshufd  XMM7,XMM0,0
          subps   XMM4,XMM7
          movaps  XMM5,[eax+100h]
          movss   XMM0,[edx+ 14h]
          pshufd  XMM7,XMM0,0
          subps   XMM5,XMM7
          movaps  XMM1,XMM4
          mulps   XMM4,XMM4
          movaps  XMM6,[eax+110h]
          movss   XMM0,[edx+ 18h]
          movaps  XMM2,XMM5
          mulps   XMM5,XMM5
          pshufd  XMM7,XMM0,0
          subps   XMM6,XMM7
          movaps  XMM3,XMM6
          mulps   XMM6,XMM6
          addps   XMM4,XMM5
          movss   XMM0,[edx+ 28h]
          pshufd  XMM7,XMM0,0
          subps   XMM4,XMM7
          addps   XMM4,XMM6
          ; b = Ray.x * pvec.x + Ray.y * pvec.y + Ray.z * pvec.z
          mulps   XMM1,[eax+180h]
          mulps   XMM2,[eax+190h]
          mulps   XMM3,[eax+200h]
          addps   XMM1,XMM2
          addps   XMM1,XMM3
          ; d = b*b-cterm
          movaps  XMM0,XMM1
          mulps   XMM1,XMM1
          subps   XMM1,XMM4

          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM1,XMM7,1
          movss   XMM6,[fone   ]
          pshufd  XMM7,XMM6,0
          andps   XMM1,XMM7

          movaps  [eax+70h],XMM1
          ret

;void RV_IntersectCylinder0(RV_Cylinder *c)
;{
;  vector TRay=vector((*RV_RayPtr).x*c->Tb.M11 + (*RV_RayPtr).y*c->Tb.M21 + (*RV_RayPtr).z*c->Tb.M31,
;                     (*RV_RayPtr).x*c->Tb.M12 + (*RV_RayPtr).y*c->Tb.M22 + (*RV_RayPtr).z*c->Tb.M32,
;                     (*RV_RayPtr).x*c->Tb.M13 + (*RV_RayPtr).y*c->Tb.M23 + (*RV_RayPtr).z*c->Tb.M33);
;  if(c->lastframe != cframe){
;    c->TCam  = (*RV_CamPtr) * c->Tb;
;    if(c->r_top){
;      c->cterm = c->TCam.x*c->TCam.x + c->TCam.y*c->TCam.y - sqr(1.0f - c->r_top*c->TCam.z);
;    } else {
;      c->cterm = c->TCam.x*c->TCam.x + c->TCam.y*c->TCam.y -     1.0f;
;    }
;    c->lastframe = cframe;
;  }
;  float a,b,d;
;  if(c->r_top){
;    a = TRay.x*   TRay.x + TRay.y*   TRay.y - sqr             (       c->r_top*   TRay.z);
;    b = TRay.x*c->TCam.x + TRay.y*c->TCam.y + c->r_top*TRay.z*(1.0f - c->r_top*c->TCam.z);
;  } else {
;    a = TRay.x*   TRay.x + TRay.y*   TRay.y;
;    b = TRay.x*c->TCam.x + TRay.y*c->TCam.y;
;  }
;  d = b*b-a*c->cterm;
;  if(d<=0.0f){ RV_IntPtr->t=-1.0f; return; }

IntersectCylinder0:
;  vector TRay=vector((*RV_RayPtr).x*c->Tb.M11 + (*RV_RayPtr).y*c->Tb.M21 + (*RV_RayPtr).z*c->Tb.M31,
;                     (*RV_RayPtr).x*c->Tb.M12 + (*RV_RayPtr).y*c->Tb.M22 + (*RV_RayPtr).z*c->Tb.M32,
;                     (*RV_RayPtr).x*c->Tb.M13 + (*RV_RayPtr).y*c->Tb.M23 + (*RV_RayPtr).z*c->Tb.M33);
          ;movss   XMM7,[eax+10h]
          ;pshufd  XMM0,XMM7,0
          ;movups  XMM6,[edx+Tb.M11]
          ;mulps   XMM0,XMM6
          ;movss   XMM7,[eax+14h]
          ;pshufd  XMM1,XMM7,0
          ;movups  XMM6,[edx+Tb.M21]
          ;mulps   XMM1,XMM6
          ;movss   XMM7,[eax+18h]
          ;pshufd  XMM2,XMM7,0
          ;movups  XMM6,[edx+Tb.M31]
          ;mulps   XMM2,XMM6
          ;addps   XMM0,XMM1
          ;addps   XMM0,XMM2

          ;movss   XMM0,[eax+10h]
          ;movss   XMM1,[eax+14h]
          ;movss   XMM2,[eax+18h]
          ;
          ;movss   XMM3,[edx+Tb.M11]
          ;mulss   XMM3,XMM0
          ;movss   XMM4,[edx+Tb.M21]
          ;mulss   XMM4,XMM1
          ;movss   XMM5,[edx+Tb.M31]
          ;mulss   XMM5,XMM2
          ;addss   XMM3,XMM4
          ;addss   XMM3,XMM5
          ;
          ;movss   XMM4,[edx+Tb.M12]
          ;mulss   XMM4,XMM0
          ;movss   XMM5,[edx+Tb.M22]
          ;mulss   XMM5,XMM1
          ;movss   XMM6,[edx+Tb.M32]
          ;mulss   XMM6,XMM2
          ;addss   XMM4,XMM5
          ;addss   XMM4,XMM6
          ;
          ;movss   XMM5,[edx+Tb.M13]
          ;mulss   XMM5,XMM0
          ;movss   XMM6,[edx+Tb.M23]
          ;mulss   XMM6,XMM1
          ;movss   XMM7,[edx+Tb.M33]
          ;mulss   XMM7,XMM2
          ;addss   XMM5,XMM6
          ;addss   XMM5,XMM7

          ; is precalculation already done for this frame?
          mov    bx,word [_cframe]    ; current frame
          cmp    bx,word [edx+0Ch]    ; = last precalculated frame?
          je     .samefrm             ; then skip precalculation

.samefrm: ret

IntersectPara1:
          ; calculate vector-dot-product ray * normal of plane
          movss  XMM0,[eax+70h] ;  Ray.x
          mulss  XMM0,[edx+34h] ; *N.x
          movss  XMM1,[eax+74h] ;  Ray.y
          mulss  XMM1,[edx+38h] ; *N.y
          addss  XMM0,XMM1      ; +
          movss  XMM2,[eax+78h] ;  Ray.z
          mulss  XMM2,[edx+3Ch] ; *N.z
          addss  XMM0,XMM2      ; +

          ; is surface doublesided?
          test   word [edx+02h],0004h
          jne    .cont1
          ; then only exit if ray is parallel to plane
          comiss XMM0,[fzero  ]
          je     near outside1
          jmp    .cont2
.cont1:   ; else exit if ray hits backface (backface culling)
          comiss XMM0,[fzero  ]
          jnc    near outside1

.cont2:   ; cpos = (p->base - Org)%(p->N)
          movss  XMM1,[edx+10h]
          subss  XMM1,[eax+60h]
          mulss  XMM1,[edx+34h]
          movss  XMM2,[edx+14h]
          subss  XMM2,[eax+64h]
          mulss  XMM2,[edx+38h]
          addss  XMM1,XMM2
          movss  XMM3,[edx+18h]
          subss  XMM3,[eax+68h]
          mulss  XMM3,[edx+3Ch]
          addss  XMM1,XMM3
         
          ; intersection parameter t = cpos / (Ray*N)
          divss  XMM1,XMM0
          movss  [eax+50h],XMM1

          ; exit if t is negative (intersection is behind camera)
          comiss XMM1,[fzero  ]
          jc     near outside1

          ; intersection point IP = Org + t * Dir;
          movss  XMM0,[eax+70h]
          mulss  XMM0,XMM1
          addss  XMM0,[eax+60h]
          movss  [eax+20h],XMM0
          movss  XMM2,[eax+74h]
          mulss  XMM2,XMM1
          addss  XMM2,[eax+64h]
          movss  [eax+24h],XMM2
          movss  XMM3,[eax+78h]
          mulss  XMM3,XMM1
          addss  XMM3,[eax+68h]
          movss  [eax+28h],XMM3

          jmp    near TriPara01

IntersectPara0:
          ; calculate vector-dot-product ray * normal of plane
          movss  XMM0,[eax+10h] ;  Ray.x
          mulss  XMM0,[edx+34h] ; *N.x
          movss  XMM1,[eax+14h] ;  Ray.y
          mulss  XMM1,[edx+38h] ; *N.y
          addss  XMM0,XMM1      ; +
          movss  XMM2,[eax+18h] ;  Ray.z
          mulss  XMM2,[edx+3Ch] ; *N.z
          addss  XMM0,XMM2      ; +

          ; is surface doublesided?
          test   word [edx+02h],0004h
          jne    .cont1
          ; then only exit if ray is parallel to plane
          comiss XMM0,[fzero  ]
          je     near outside1
          jmp    .cont2
.cont1:   ; else exit if ray hits backface (backface culling)
          comiss XMM0,[fzero  ]
          jnc    near outside1

.cont2:   ; is precalculation already done for this frame?
          mov    bx,word [_cframe]    ; current frame
          cmp    bx,word [edx+0Ch]    ; = last precalculated frame?
          je     .samefrm             ; then skip precalculation
          mov    word [edx+0Ch],bx    ; else store current frame number and precalculate:
          ;p->cpos       = (p->base - Camera)%(p->N);
          movss  XMM1,[edx+10h]
          subss  XMM1,[eax    ]
          mulss  XMM1,[edx+34h]
          movss  XMM2,[edx+14h]
          subss  XMM2,[eax+04h]
          mulss  XMM2,[edx+38h]
          addss  XMM1,XMM2
          movss  XMM3,[edx+18h]
          subss  XMM3,[eax+08h]
          mulss  XMM3,[edx+3Ch]
          addss  XMM1,XMM3
          movss  [edx+40h],XMM1

.samefrm: ; intersection parameter t = cpos / (Ray*N)
          movss  XMM1,[edx+40h]
          divss  XMM1,XMM0
          movss  [eax+50h],XMM1

          ; exit if t is negative (intersection is behind camera)
          comiss XMM1,[fzero  ]
          jc     near outside1

          ; intersection point IP = Camera + t * Ray;
          movss  XMM0,[eax+10h]
          mulss  XMM0,XMM1
          addss  XMM0,[eax    ]
          movss  [eax+20h],XMM0
          movss  XMM2,[eax+14h]
          mulss  XMM2,XMM1
          addss  XMM2,[eax+04h]
          movss  [eax+24h],XMM2
          movss  XMM3,[eax+18h]
          mulss  XMM3,XMM1
          addss  XMM3,[eax+08h]
          movss  [eax+28h],XMM3
          ;movss  XMM4,[eax+1Ch]
          ;mulss  XMM4,XMM1
          ;addss  XMM4,[eax+0Ch]
          ;movss  [eax+2Ch],XMM4

          ;pshufd XMM0,XMM1,0
          ;mulps  XMM0,[eax+10h]
          ;addps  XMM0,[eax    ]
          ;movaps [eax+20h],XMM0

          ;pshufd XMM0,XMM1,0
          ;movups XMM2,[eax+10h]
          ;mulps  XMM0,XMM2
          ;movups XMM3,[eax    ]
          ;addps  XMM0,XMM3
          ;movups [eax+20h],XMM0

TriPara01:
          ;switch(p->algn){
          mov    bx, word [edx+4Ch]
.case0:   cmp    bx,0
          jne    .case1
	  ; surface parameter v = ((IP.y - base.y)*edg1.x - (IP.x - base.x)*edg1.y) * (1/denominator)
          subss   XMM0,[edx+10h]    ; IP.x - base.x
          movss   XMM5,XMM0         ; store result for later use
          mulss   XMM0,[edx+20h]    ; *edg1.y
          subss   XMM2,[edx+14h]    ; IP.y - base.y
          mulss   XMM2,[edx+1Ch]    ; *edg1.x
          subss   XMM2,XMM0         ; -
          mulss   XMM2,[edx+44h]    ; *(1/denominator)
          ; exit if v<0
          comiss  XMM2,[fzero  ]
          jc      near outside1
          movss   [eax+44h],XMM2    ; store v
          ; surface parameter u =  (IP.x - base.x - v*edg2.x) / edg1.x
          mulss   XMM2,[edx+28h]    ; v*edg2.x
          subss   XMM5,XMM2         ; subtract from stored result (IP.x - base.x)
          divss   XMM5,[edx+1Ch]    ; /edg1.x
          jmp    .endcase           ; break
.case1:   cmp    bx,1
          jne    .case2
	  ; surface parameter v = ((IP.z - base.z)*edg1.y - (IP.y - base.y)*edg1.z) * (1/denominator)
          subss   XMM2,[edx+14h]    ; IP.y - base.y
          movss   XMM5,XMM2         ; store result for later use
          mulss   XMM2,[edx+24h]    ; *edg1.z
          subss   XMM3,[edx+18h]    ; IP.z - base.z
          mulss   XMM3,[edx+20h]    ; *edg1.y
          subss   XMM3,XMM2         ; -
          mulss   XMM3,[edx+44h]    ; *(1/denominator)
          ; exit if v<0
          comiss  XMM3,[fzero  ]
          jc      near outside1
          movss   [eax+44h],XMM3    ; store v
          ; surface parameter u =  (IP.y - base.y - v*edg2.y) / edg1.y
          mulss   XMM3,[edx+2Ch]    ; v*edg2.y
          subss   XMM5,XMM3         ; subtract from stored result (IP.y - base.y)
          divss   XMM5,[edx+20h]    ; /edg1.y
          jmp    .endcase           ; break
.case2:   cmp    bx,2
          jne    .case3
	  ; surface parameter v = ((IP.z - base.z)*edg1.x - (IP.x - base.x)*edg1.z) * (1/denominator)
          subss   XMM0,[edx+10h]    ; IP.x - base.x
          movss   XMM5,XMM0         ; store result for later use
          mulss   XMM0,[edx+24h]    ; *edg1.z
          subss   XMM3,[edx+18h]    ; IP.z - base.z
          mulss   XMM3,[edx+1Ch]    ; *edg1.x
          subss   XMM3,XMM0         ; -
          mulss   XMM3,[edx+44h]    ; *(1/denominator)
          ; exit if v<0
          comiss  XMM3,[fzero  ]
          jc      near outside1
          movss   [eax+44h],XMM3    ; store v
          ; surface parameter u =  (IP.x - base.x - v*edg2.x) / edg1.x
          mulss   XMM3,[edx+28h]    ; v*edg2.x
          subss   XMM5,XMM3         ; subtract from stored result (IP.x - base.x)
          divss   XMM5,[edx+1Ch]    ; /edg1.x
          jmp    .endcase           ; break
.case3:   cmp    bx,3
          jne    .case4
	  ; surface parameter v = ((IP.x - base.x)*edg1.y - (IP.y - base.y)*edg1.x) * (1/denominator)
          subss   XMM2,[edx+14h]    ; IP.y - base.y
          movss   XMM5,XMM2         ; store result for later use
          mulss   XMM2,[edx+1Ch]    ; *edg1.x
          subss   XMM0,[edx+10h]    ; IP.x - base.x
          mulss   XMM0,[edx+20h]    ; *edg1.y
          subss   XMM0,XMM2         ; -
          mulss   XMM0,[edx+44h]    ; *(1/denominator)
          ; exit if v<0
          comiss  XMM0,[fzero  ]
          jc      near outside1
          movss   [eax+44h],XMM0    ; store v
          ; surface parameter u =  (IP.y - base.y - v*edg2.y) / edg1.y
          mulss   XMM0,[edx+2Ch]    ; v*edg2.y
          subss   XMM5,XMM0         ; subtract from stored result (IP.y - base.y)
          divss   XMM5,[edx+20h]    ; /edg1.y
          jmp    .endcase           ; break
.case4:   cmp    bx,4
          jne    .case5
	  ; surface parameter v = ((IP.y - base.y)*edg1.z - (IP.z - base.z)*edg1.y) * (1/denominator)
          subss   XMM3,[edx+18h]    ; IP.z - base.z
          movss   XMM5,XMM3         ; store result for later use
          mulss   XMM3,[edx+20h]    ; *edg1.y
          subss   XMM2,[edx+14h]    ; IP.y - base.y
          mulss   XMM2,[edx+24h]    ; *edg1.z
          subss   XMM2,XMM3         ; -
          mulss   XMM2,[edx+44h]    ; *(1/denominator)
          ; exit if v<0
          comiss  XMM2,[fzero  ]
          jc      near outside1
          movss   [eax+44h],XMM2    ; store v
          ; surface parameter u =  (IP.z - base.z - v*edg2.z) / edg1.z
          mulss   XMM2,[edx+30h]    ; v*edg2.z
          subss   XMM5,XMM2         ; subtract from stored result (IP.z - base.z)
          divss   XMM5,[edx+24h]    ; /edg1.z
          jmp    .endcase           ; break
.case5:   cmp    bx,5
          jne    near outside1
	  ; surface parameter v = ((IP.x - base.x)*edg1.z - (IP.z - base.z)*edg1.x) * (1/denominator)
          subss   XMM3,[edx+18h]    ; IP.z - base.z
          movss   XMM5,XMM3         ; store result for later use
          mulss   XMM3,[edx+1Ch]    ; *edg1.x
          subss   XMM0,[edx+10h]    ; IP.x - base.x
          mulss   XMM0,[edx+24h]    ; *edg1.z
          subss   XMM0,XMM3         ; -
          mulss   XMM0,[edx+44h]    ; *(1/denominator)
          ; exit if v<0
          comiss  XMM0,[fzero  ]
          jc      near outside1
          movss   [eax+44h],XMM0    ; store v
          ; surface parameter u =  (IP.z - base.z - v*edg2.z) / edg1.z
          mulss   XMM0,[edx+30h]    ; v*edg2.z
          subss   XMM5,XMM0         ; subtract from stored result (IP.z - base.z)
          divss   XMM5,[edx+24h]    ; /edg1.z

.endcase: comiss  XMM5,[fzero  ]    ; u<0 ?
          jc      outside1          ; then exit with negative result
          movss   [eax+40h],XMM5    ; store u      
          test    word [edx],0FFFFh ; are we a parallelogram ?
          jnz     .para             ; then goto .para else continue .triangl
.triangl: addss   XMM5, [eax+44h]   ; u+v
          comiss  XMM5, [fone   ]   ; >1 ?
          jnc     outside1          ; then exit with negative result
          ret                       ; else return positive
.para:    comiss  XMM5,[fone   ]    ; u>1 ?
          jnc     outside1          ; then exit with negative result
          movss   XMM0,[eax+44h]    ; v
          comiss  XMM0,[fone   ]    ; >1 ?
          jnc     outside1          ; then exit with negative result
          ret                       ; else return positive
outside1: mov     dword [eax+50h], 0BF800000h ; set intersection parameter t = -1 (no desirable intersection)
          ret

SIMD_Int_Para0:
          ; calculate vector-dot-product ray * normal of plane
          movss   XMM7,[edx+34h] ; N.x
          pshufd  XMM0,XMM7,0    ; *
          mulps   XMM0,[eax+40h] ; Ray.x
          movss   XMM7,[edx+38h] ; N.y
          pshufd  XMM1,XMM7,0    ; *
          mulps   XMM1,[eax+50h] ; Ray.y
          movss   XMM7,[edx+3Ch] ; N.z
          pshufd  XMM2,XMM7,0    ; *
          mulps   XMM2,[eax+60h] ; Ray.z
          addps   XMM0,XMM1
          addps   XMM0,XMM2

          ; is surface doublesided?
          test    word [edx+02h],0004h
          jne     .cont1
          ; then only exit if ray is parallel to plane
          comiss  XMM0,[fzero  ]
          je      near outside1
          jmp     .cont2
.cont1:   ; else exit if ray hits backface (backface culling)
          comiss  XMM0,[fzero  ]
          jnc     near .outside

.cont2:   ; is precalculation already done for this frame?
          mov     bx,word [_cframe]    ; current frame
          cmp     bx,word [edx+0Ch]    ; = last precalculated frame?
          je      .samefrm             ; then skip precalculation
          mov     word [edx+0Ch],bx    ; else store current frame number and precalculate:
          ;p->cpos       = (p->base - Camera)%(p->N);
          movss   XMM1,[edx+10h]
          subss   XMM1,[eax    ]
          mulss   XMM1,[edx+34h]
          movss   XMM2,[edx+14h]
          subss   XMM2,[eax+04h]
          mulss   XMM2,[edx+38h]
          addss   XMM1,XMM2
          movss   XMM3,[edx+18h]
          subss   XMM3,[eax+08h]
          mulss   XMM3,[edx+3Ch]
          addss   XMM1,XMM3
          movss   [edx+40h],XMM1

.samefrm: ; intersection parameter t = cpos / (Ray*N)
          movss   XMM7,[edx+40h]
          pshufd  XMM1,XMM7,0
          divps   XMM1,XMM0
          movaps  [eax+70h],XMM1

          ; exit if t is negative (intersection is behind camera)
          ;comiss XMM1,[fzero  ]
          ;jc     near .outside

          ; intersection point IP = Camera + t * Ray;
          movaps  XMM0,[eax+40h]
          mulps   XMM0,XMM1
          movss   XMM7,[eax    ]
          pshufd  XMM6,XMM7,0
          addps   XMM0,XMM6
          movaps  [eax+080h],XMM0
          movaps  XMM2,[eax+50h]
          mulps   XMM2,XMM1
          movss   XMM7,[eax+04h]
          pshufd  XMM6,XMM7,0
          addps   XMM2,XMM6
          movaps  [eax+090h],XMM2
          movaps  XMM3,[eax+60h]
          mulps   XMM3,XMM1
          movss   XMM7,[eax+08h]
          pshufd  XMM6,XMM7,0
          addps   XMM3,XMM6
          movaps  [eax+0A0h],XMM3

          ;switch(p->algn){
          mov     bx, word [edx+4Ch]
.case0:   cmp     bx,0
          jne     near .case1
	  ; surface parameter v = ((IP.y - base.y)*edg1.x - (IP.x - base.x)*edg1.y) * (1/denominator)
          movss   XMM7,[edx+10h]
          pshufd  XMM6,XMM7,0
          subps   XMM0,XMM6         ; IP.x - base.x
          movaps  XMM5,XMM0         ; store result for later use
          movss   XMM7,[edx+20h]
          pshufd  XMM6,XMM7,0
          mulps   XMM0,XMM6         ; *edg1.y
          movss   XMM7,[edx+14h]
          pshufd  XMM6,XMM7,0
          subps   XMM2,XMM6         ; IP.y - base.y
          movss   XMM7,[edx+1Ch]
          pshufd  XMM4,XMM7,0
          mulps   XMM2,XMM4         ; *edg1.x
          subps   XMM2,XMM0         ; -
          movss   XMM7,[edx+44h]
          pshufd  XMM6,XMM7,0
          mulps   XMM2,XMM6         ; *(1/denominator)
          ; exit if v<0
          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM2,1
          movmskps ebx,XMM7
          test    bx,15
          jz      near .outside
          movaps  [eax+0C0h],XMM2   ; store v
          ; surface parameter u =  (IP.x - base.x - v*edg2.x) / edg1.x
          movss   XMM7,[edx+28h]
          pshufd  XMM6,XMM7,0
          mulps   XMM2,XMM6         ; v*edg2.x
          subps   XMM5,XMM2         ; subtract from stored result (IP.x - base.x)
          divps   XMM5,XMM4         ; /edg1.x
          jmp    .endcase           ; break
.case1:   cmp     bx,1
          jne     near .case2
	  ; surface parameter v = ((IP.z - base.z)*edg1.y - (IP.y - base.y)*edg1.z) * (1/denominator)
          movss   XMM7,[edx+14h]
          pshufd  XMM6,XMM7,0
          subps   XMM2,XMM6         ; IP.y - base.y
          movaps  XMM5,XMM2         ; store result for later use
          movss   XMM7,[edx+24h]
          pshufd  XMM6,XMM7,0
          mulps   XMM2,XMM6         ; *edg1.z
          movss   XMM7,[edx+18h]
          pshufd  XMM6,XMM7,0
          subps   XMM3,XMM6         ; IP.z - base.z
          movss   XMM7,[edx+20h]
          pshufd  XMM4,XMM7,0
          mulps   XMM3,XMM4         ; *edg1.y
          subps   XMM3,XMM2         ; -
          movss   XMM7,[edx+44h]
          pshufd  XMM6,XMM7,0
          mulps   XMM3,XMM6         ; *(1/denominator)
          ; exit if v<0
          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM3,1
          movmskps ebx,XMM7
          test    bx,15
          jz      near .outside
          movaps  [eax+0C0h],XMM3   ; store v
          ; surface parameter u =  (IP.y - base.y - v*edg2.y) / edg1.y
          movss   XMM7,[edx+2Ch]
          pshufd  XMM6,XMM7,0
          mulps   XMM3,XMM6         ; v*edg2.y
          subps   XMM5,XMM3         ; subtract from stored result (IP.x - base.x)
          divps   XMM5,XMM4         ; /edg1.y
          jmp    .endcase           ; break
.case2:   cmp     bx,2
          jne     near .case3
	  ; surface parameter v = ((IP.z - base.z)*edg1.x - (IP.x - base.x)*edg1.z) * (1/denominator)
          movss   XMM7,[edx+10h]
          pshufd  XMM6,XMM7,0
          subps   XMM0,XMM6         ; IP.x - base.x
          movaps  XMM5,XMM0         ; store result for later use
          movss   XMM7,[edx+24h]
          pshufd  XMM6,XMM7,0
          mulps   XMM0,XMM6         ; *edg1.z
          movss   XMM7,[edx+18h]
          pshufd  XMM6,XMM7,0
          subps   XMM3,XMM6         ; IP.z - base.z
          movss   XMM7,[edx+1Ch]
          pshufd  XMM4,XMM7,0
          mulps   XMM3,XMM4         ; *edg1.x
          subps   XMM3,XMM0         ; -
          movss   XMM7,[edx+44h]
          pshufd  XMM6,XMM7,0
          mulps   XMM3,XMM6         ; *(1/denominator)
          ; exit if v<0
          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM3,1
          movmskps ebx,XMM7
          test    bx,15
          jz      near .outside
          movaps  [eax+0C0h],XMM3   ; store v
          ; surface parameter u =  (IP.x - base.x - v*edg2.x) / edg1.x
          movss   XMM7,[edx+28h]
          pshufd  XMM6,XMM7,0
          mulps   XMM3,XMM6         ; v*edg2.x
          subps   XMM5,XMM3         ; subtract from stored result (IP.x - base.x)
          divps   XMM5,XMM4         ; /edg1.x
          jmp    .endcase           ; break
.case3:   cmp     bx,3
          jne     near .case4
	  ; surface parameter v = ((IP.x - base.x)*edg1.y - (IP.y - base.y)*edg1.x) * (1/denominator)
          movss   XMM7,[edx+14h]
          pshufd  XMM6,XMM7,0
          subps   XMM2,XMM6         ; IP.y - base.y
          movaps  XMM5,XMM2         ; store result for later use
          movss   XMM7,[edx+1Ch]
          pshufd  XMM6,XMM7,0
          mulps   XMM2,XMM6         ; *edg1.x
          movss   XMM7,[edx+10h]
          pshufd  XMM6,XMM7,0
          subps   XMM0,XMM6         ; IP.x - base.x
          movss   XMM7,[edx+20h]
          pshufd  XMM4,XMM7,0
          mulps   XMM0,XMM4         ; *edg1.y
          subps   XMM0,XMM2         ; -
          movss   XMM7,[edx+44h]
          pshufd  XMM6,XMM7,0
          mulps   XMM0,XMM6         ; *(1/denominator)
          ; exit if v<0
          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM0,1
          movmskps ebx,XMM7
          test    bx,15
          jz      near .outside
          movaps  [eax+0C0h],XMM0   ; store v
          ; surface parameter u =  (IP.y - base.y - v*edg2.y) / edg1.y
          movss   XMM7,[edx+2Ch]
          pshufd  XMM6,XMM7,0
          mulps   XMM0,XMM6         ; v*edg2.y
          subps   XMM5,XMM0         ; subtract from stored result (IP.x - base.x)
          divps   XMM5,XMM4         ; /edg1.y
          jmp    .endcase           ; break
.case4:   cmp     bx,4
          jne     near .case5
	  ; surface parameter v = ((IP.y - base.y)*edg1.z - (IP.z - base.z)*edg1.y) * (1/denominator)
          movss   XMM7,[edx+18h]
          pshufd  XMM6,XMM7,0
          subps   XMM3,XMM6         ; IP.z - base.z
          movaps  XMM5,XMM3         ; store result for later use
          movss   XMM7,[edx+20h]
          pshufd  XMM6,XMM7,0
          mulps   XMM3,XMM6         ; *edg1.y
          movss   XMM7,[edx+14h]
          pshufd  XMM6,XMM7,0
          subps   XMM2,XMM6         ; IP.y - base.y
          movss   XMM7,[edx+24h]
          pshufd  XMM4,XMM7,0
          mulps   XMM2,XMM4         ; *edg1.z
          subps   XMM2,XMM3         ; -
          movss   XMM7,[edx+44h]
          pshufd  XMM6,XMM7,0
          mulps   XMM2,XMM6         ; *(1/denominator)
          ; exit if v<0
          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM2,1
          movmskps ebx,XMM7
          test    bx,15
          jz      near .outside
          movaps  [eax+0C0h],XMM2   ; store v
          ; surface parameter u =  (IP.z - base.z - v*edg2.z) / edg1.z
          movss   XMM7,[edx+30h]
          pshufd  XMM6,XMM7,0
          mulps   XMM2,XMM6         ; v*edg2.z
          subps   XMM5,XMM2         ; subtract from stored result (IP.x - base.x)
          divps   XMM5,XMM4         ; /edg1.z
          jmp    .endcase           ; break
.case5:   cmp     bx,5
          jne     near .outside
	  ; surface parameter v = ((IP.x - base.x)*edg1.z - (IP.z - base.z)*edg1.x) * (1/denominator)
          movss   XMM7,[edx+18h]
          pshufd  XMM6,XMM7,0
          subps   XMM3,XMM6         ; IP.z - base.z
          movaps  XMM5,XMM3         ; store result for later use
          movss   XMM7,[edx+1Ch]
          pshufd  XMM6,XMM7,0
          mulps   XMM3,XMM6         ; *edg1.x
          movss   XMM7,[edx+10h]
          pshufd  XMM6,XMM7,0
          subps   XMM0,XMM6         ; IP.x - base.x
          movss   XMM7,[edx+24h]
          pshufd  XMM4,XMM7,0
          mulps   XMM0,XMM4         ; *edg1.z
          subps   XMM0,XMM3         ; -
          movss   XMM7,[edx+44h]
          pshufd  XMM6,XMM7,0
          mulps   XMM0,XMM6         ; *(1/denominator)
          ; exit if v<0
          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM0,1
          movmskps ebx,XMM7
          test    bx,15
          jz      near .outside
          movaps  [eax+0C0h],XMM0   ; store v
          ; surface parameter u =  (IP.z - base.z - v*edg2.z) / edg1.z
          movss   XMM7,[edx+30h]
          pshufd  XMM6,XMM7,0
          mulps   XMM0,XMM6         ; v*edg2.z
          subps   XMM5,XMM0         ; subtract from stored result (IP.z - base.z)
          divps   XMM5,XMM4         ; /edg1.z
.endcase: ; u<0 ?
          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM5,1
          movmskps ecx,XMM7
          test    cx,15
          jz      near .outside     ; then exit with negative result
          and     bx,cx
          movaps  [eax+0B0h],XMM5   ; store u      
          test    word [edx],0FFFFh ; are we a parallelogram ?
          jnz     .para             ; then goto .para else continue .triangl
.triangl: addps   XMM5,[eax+0C0h]   ; u+v > 1 ?
          movss   XMM6,[fone   ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM5,6
          movmskps ecx,XMM7
          test    cx,15
          jz      .outside          ; then exit with negative result
          jmp     .itest
.para:    ; u>1 ?
          movss   XMM6,[fone   ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM5,6
          movmskps ecx,XMM7
          test    cx,15
          jz      .outside          ; then exit with negative result
          and     bx,cx
          ; v>1 ?
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,[eax+0C0h],6
          movmskps ecx,XMM7
          test    cx,15
          jz      .outside          ; then exit with negative result
.itest:   and     bx,cx
          test    bx,1
          jnz     .c1
          mov     dword [eax+70h],0BF800000h
.c1:      test    bx,2
          jnz     .c2
          mov     dword [eax+74h],0BF800000h
.c2:      test    bx,4
          jnz     .c3
          mov     dword [eax+78h],0BF800000h
.c3:      test    bx,8
          jnz     .c4
          mov     dword [eax+7Ch],0BF800000h
.c4:      ret                       ; else return positive
.outside: movss   XMM2,[fminus1]
          pshufd  XMM3,XMM2,0
          movaps  [eax+70h],XMM3
          ret

SIMD_Int_ParaS:
          ; calculate vector-dot-product ray * normal of plane
          movss   XMM7,[edx+034h] ; N.x
          pshufd  XMM0,XMM7,0     ; *
          mulps   XMM0,[eax+180h] ; Ray.x
          movss   XMM7,[edx+038h] ; N.y
          pshufd  XMM1,XMM7,0     ; *
          mulps   XMM1,[eax+190h] ; Ray.y
          movss   XMM7,[edx+03Ch] ; N.z
          pshufd  XMM2,XMM7,0     ; *
          mulps   XMM2,[eax+200h] ; Ray.z
          addps   XMM0,XMM1
          addps   XMM0,XMM2

          ; is surface doublesided?
          test    word [edx+02h],0004h
          jne     .cont1
          ; then only exit if ray is parallel to plane
          comiss  XMM0,[fzero  ]
          je      near outside1
          jmp     .cont2
.cont1:   ; else exit if ray hits backface (backface culling)
          comiss  XMM0,[fzero  ]
          jnc     near .outside

.cont2:   ;p->cpos       = (p->base - IP)%(p->N);
          movss   XMM1,[edx+010h]
          pshufd  XMM1,XMM1,0
          subps   XMM1,[eax+0F0h]
          movss   XMM4,[edx+034h]
          pshufd  XMM4,XMM4,0
          mulps   XMM1,XMM4
          movss   XMM2,[edx+014h]
          pshufd  XMM2,XMM2,0
          subps   XMM2,[eax+100h]
          movss   XMM4,[edx+038h]
          pshufd  XMM4,XMM4,0
          mulps   XMM2,XMM4
          addps   XMM1,XMM2
          movss   XMM3,[edx+018h]
          pshufd  XMM3,XMM3,0
          subps   XMM3,[eax+110h]
          movss   XMM4,[edx+03Ch]
          pshufd  XMM4,XMM4,0
          mulps   XMM3,XMM4
          addps   XMM1,XMM3

          ; intersection parameter t = cpos / (Ray*N)
          divps   XMM1,XMM0

          movss   XMM7,[fzero]
          pshufd  XMM7,XMM7,0
          movaps  [eax+070h],XMM7

          ; exit if t is negative (intersection is behind camera)
          ;comiss XMM1,[fzero  ]
          ;jc     near .outside
          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM1,1
          movmskps ecx,XMM7
          test    cx,15
          jz      near .outside

          ; intersection point IP = Camera + t * Ray;
          movaps  XMM0,[eax+180h]
          mulps   XMM0,XMM1
          addps   XMM0,[eax+0F0h]
          movaps  XMM2,[eax+190h]
          mulps   XMM2,XMM1
          addps   XMM2,[eax+100h]
          movaps  XMM3,[eax+200h]
          mulps   XMM3,XMM1
          addps   XMM3,[eax+110h]

          ;switch(p->algn){
          mov     bx, word [edx+4Ch]
.case0:   cmp     bx,0
          jne     near .case1
	  ; surface parameter v = ((IP.y - base.y)*edg1.x - (IP.x - base.x)*edg1.y) * (1/denominator)
          movss   XMM7,[edx+10h]
          pshufd  XMM6,XMM7,0
          subps   XMM0,XMM6         ; IP.x - base.x
          movaps  XMM5,XMM0         ; store result for later use
          movss   XMM7,[edx+20h]
          pshufd  XMM6,XMM7,0
          mulps   XMM0,XMM6         ; *edg1.y
          movss   XMM7,[edx+14h]
          pshufd  XMM6,XMM7,0
          subps   XMM2,XMM6         ; IP.y - base.y
          movss   XMM7,[edx+1Ch]
          pshufd  XMM4,XMM7,0
          mulps   XMM2,XMM4         ; *edg1.x
          subps   XMM2,XMM0         ; -
          movss   XMM7,[edx+44h]
          pshufd  XMM6,XMM7,0
          mulps   XMM2,XMM6         ; *(1/denominator)
          ; exit if v<0
          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM2,1
          movmskps ebx,XMM7
          test    bx,15
          jz      near .outside
          movaps  [eax+0C0h],XMM2   ; store v
          ; surface parameter u =  (IP.x - base.x - v*edg2.x) / edg1.x
          movss   XMM7,[edx+28h]
          pshufd  XMM6,XMM7,0
          mulps   XMM2,XMM6         ; v*edg2.x
          subps   XMM5,XMM2         ; subtract from stored result (IP.x - base.x)
          divps   XMM5,XMM4         ; /edg1.x
          jmp    .endcase           ; break
.case1:   cmp     bx,1
          jne     near .case2
	  ; surface parameter v = ((IP.z - base.z)*edg1.y - (IP.y - base.y)*edg1.z) * (1/denominator)
          movss   XMM7,[edx+14h]
          pshufd  XMM6,XMM7,0
          subps   XMM2,XMM6         ; IP.y - base.y
          movaps  XMM5,XMM2         ; store result for later use
          movss   XMM7,[edx+24h]
          pshufd  XMM6,XMM7,0
          mulps   XMM2,XMM6         ; *edg1.z
          movss   XMM7,[edx+18h]
          pshufd  XMM6,XMM7,0
          subps   XMM3,XMM6         ; IP.z - base.z
          movss   XMM7,[edx+20h]
          pshufd  XMM4,XMM7,0
          mulps   XMM3,XMM4         ; *edg1.y
          subps   XMM3,XMM2         ; -
          movss   XMM7,[edx+44h]
          pshufd  XMM6,XMM7,0
          mulps   XMM3,XMM6         ; *(1/denominator)
          ; exit if v<0
          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM3,1
          movmskps ebx,XMM7
          test    bx,15
          jz      near .outside
          movaps  [eax+0C0h],XMM3   ; store v
          ; surface parameter u =  (IP.y - base.y - v*edg2.y) / edg1.y
          movss   XMM7,[edx+2Ch]
          pshufd  XMM6,XMM7,0
          mulps   XMM3,XMM6         ; v*edg2.y
          subps   XMM5,XMM3         ; subtract from stored result (IP.x - base.x)
          divps   XMM5,XMM4         ; /edg1.y
          jmp    .endcase           ; break
.case2:   cmp     bx,2
          jne     near .case3
	  ; surface parameter v = ((IP.z - base.z)*edg1.x - (IP.x - base.x)*edg1.z) * (1/denominator)
          movss   XMM7,[edx+10h]
          pshufd  XMM6,XMM7,0
          subps   XMM0,XMM6         ; IP.x - base.x
          movaps  XMM5,XMM0         ; store result for later use
          movss   XMM7,[edx+24h]
          pshufd  XMM6,XMM7,0
          mulps   XMM0,XMM6         ; *edg1.z
          movss   XMM7,[edx+18h]
          pshufd  XMM6,XMM7,0
          subps   XMM3,XMM6         ; IP.z - base.z
          movss   XMM7,[edx+1Ch]
          pshufd  XMM4,XMM7,0
          mulps   XMM3,XMM4         ; *edg1.x
          subps   XMM3,XMM0         ; -
          movss   XMM7,[edx+44h]
          pshufd  XMM6,XMM7,0
          mulps   XMM3,XMM6         ; *(1/denominator)
          ; exit if v<0
          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM3,1
          movmskps ebx,XMM7
          test    bx,15
          jz      near .outside
          movaps  [eax+0C0h],XMM3   ; store v
          ; surface parameter u =  (IP.x - base.x - v*edg2.x) / edg1.x
          movss   XMM7,[edx+28h]
          pshufd  XMM6,XMM7,0
          mulps   XMM3,XMM6         ; v*edg2.x
          subps   XMM5,XMM3         ; subtract from stored result (IP.x - base.x)
          divps   XMM5,XMM4         ; /edg1.x
          jmp    .endcase           ; break
.case3:   cmp     bx,3
          jne     near .case4
	  ; surface parameter v = ((IP.x - base.x)*edg1.y - (IP.y - base.y)*edg1.x) * (1/denominator)
          movss   XMM7,[edx+14h]
          pshufd  XMM6,XMM7,0
          subps   XMM2,XMM6         ; IP.y - base.y
          movaps  XMM5,XMM2         ; store result for later use
          movss   XMM7,[edx+1Ch]
          pshufd  XMM6,XMM7,0
          mulps   XMM2,XMM6         ; *edg1.x
          movss   XMM7,[edx+10h]
          pshufd  XMM6,XMM7,0
          subps   XMM0,XMM6         ; IP.x - base.x
          movss   XMM7,[edx+20h]
          pshufd  XMM4,XMM7,0
          mulps   XMM0,XMM4         ; *edg1.y
          subps   XMM0,XMM2         ; -
          movss   XMM7,[edx+44h]
          pshufd  XMM6,XMM7,0
          mulps   XMM0,XMM6         ; *(1/denominator)
          ; exit if v<0
          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM0,1
          movmskps ebx,XMM7
          test    bx,15
          jz      near .outside
          movaps  [eax+0C0h],XMM0   ; store v
          ; surface parameter u =  (IP.y - base.y - v*edg2.y) / edg1.y
          movss   XMM7,[edx+2Ch]
          pshufd  XMM6,XMM7,0
          mulps   XMM0,XMM6         ; v*edg2.y
          subps   XMM5,XMM0         ; subtract from stored result (IP.x - base.x)
          divps   XMM5,XMM4         ; /edg1.y
          jmp    .endcase           ; break
.case4:   cmp     bx,4
          jne     near .case5
	  ; surface parameter v = ((IP.y - base.y)*edg1.z - (IP.z - base.z)*edg1.y) * (1/denominator)
          movss   XMM7,[edx+18h]
          pshufd  XMM6,XMM7,0
          subps   XMM3,XMM6         ; IP.z - base.z
          movaps  XMM5,XMM3         ; store result for later use
          movss   XMM7,[edx+20h]
          pshufd  XMM6,XMM7,0
          mulps   XMM3,XMM6         ; *edg1.y
          movss   XMM7,[edx+14h]
          pshufd  XMM6,XMM7,0
          subps   XMM2,XMM6         ; IP.y - base.y
          movss   XMM7,[edx+24h]
          pshufd  XMM4,XMM7,0
          mulps   XMM2,XMM4         ; *edg1.z
          subps   XMM2,XMM3         ; -
          movss   XMM7,[edx+44h]
          pshufd  XMM6,XMM7,0
          mulps   XMM2,XMM6         ; *(1/denominator)
          ; exit if v<0
          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM2,1
          movmskps ebx,XMM7
          test    bx,15
          jz      near .outside
          movaps  [eax+0C0h],XMM2   ; store v
          ; surface parameter u =  (IP.z - base.z - v*edg2.z) / edg1.z
          movss   XMM7,[edx+30h]
          pshufd  XMM6,XMM7,0
          mulps   XMM2,XMM6         ; v*edg2.z
          subps   XMM5,XMM2         ; subtract from stored result (IP.x - base.x)
          divps   XMM5,XMM4         ; /edg1.z
          jmp    .endcase           ; break
.case5:   cmp     bx,5
          jne     near .outside
	  ; surface parameter v = ((IP.x - base.x)*edg1.z - (IP.z - base.z)*edg1.x) * (1/denominator)
          movss   XMM7,[edx+18h]
          pshufd  XMM6,XMM7,0
          subps   XMM3,XMM6         ; IP.z - base.z
          movaps  XMM5,XMM3         ; store result for later use
          movss   XMM7,[edx+1Ch]
          pshufd  XMM6,XMM7,0
          mulps   XMM3,XMM6         ; *edg1.x
          movss   XMM7,[edx+10h]
          pshufd  XMM6,XMM7,0
          subps   XMM0,XMM6         ; IP.x - base.x
          movss   XMM7,[edx+24h]
          pshufd  XMM4,XMM7,0
          mulps   XMM0,XMM4         ; *edg1.z
          subps   XMM0,XMM3         ; -
          movss   XMM7,[edx+44h]
          pshufd  XMM6,XMM7,0
          mulps   XMM0,XMM6         ; *(1/denominator)
          ; exit if v<0
          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM0,1
          movmskps ebx,XMM7
          test    bx,15
          jz      near .outside
          movaps  [eax+0C0h],XMM0   ; store v
          ; surface parameter u =  (IP.z - base.z - v*edg2.z) / edg1.z
          movss   XMM7,[edx+30h]
          pshufd  XMM6,XMM7,0
          mulps   XMM0,XMM6         ; v*edg2.z
          subps   XMM5,XMM0         ; subtract from stored result (IP.z - base.z)
          divps   XMM5,XMM4         ; /edg1.z
.endcase: ; integrate result of t-test with v-test
          and     bx,cx
          ; u<0 ?
          movss   XMM6,[fzero  ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM5,1
          movmskps ecx,XMM7
          test    cx,15
          jz      near .outside     ; then exit with negative result
          and     bx,cx
          movaps  [eax+0B0h],XMM5   ; store u      
          test    word [edx],0FFFFh ; are we a parallelogram ?
          jnz     .para             ; then goto .para else continue .triangl
.triangl: addps   XMM5,[eax+0C0h]   ; u+v > 1 ?
          movss   XMM6,[fone   ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM5,6
          movmskps ecx,XMM7
          test    cx,15
          jz      near .outside          ; then exit with negative result
          jmp     .itest
.para:    ; u>1 ?
          movss   XMM6,[fone   ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM5,6
          movmskps ecx,XMM7
          test    cx,15
          jz      near .outside          ; then exit with negative result
          and     bx,cx
          ; v>1 ?
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,[eax+0C0h],6
          movmskps ecx,XMM7
          test    cx,15
          jz      near .outside          ; then exit with negative result
.itest:   and     bx,cx
          test    bx,1
          jnz     .c1
          mov     dword [eax+070h],03F800000h
.c1:      test    bx,2
          jnz     .c2
          mov     dword [eax+074h],03F800000h
.c2:      test    bx,4
          jnz     .c3
          mov     dword [eax+078h],03F800000h
.c3:      test    bx,8
          jnz     .c4
          mov     dword [eax+07Ch],03F800000h
.c4:      ret                       ; else return positive
.outside: movss   XMM2,[fone  ]
          pshufd  XMM3,XMM2,0
          movaps  [eax+070h],XMM3
          ret

_RV_TraceList0:
          push   ebp
          mov    ebp,esp
          push   eax
          push   ebx
          push   ecx
          mov    ebx,[ebp+8]      ; parameter to function (primitive pointer)
          mov    eax,_RV_Data     ; pointer to camera and ray vectors
          and    eax,0FFFFFFF0h   ; align to 16 byte

.loop:    mov    edx,[ebx]
          push   ebx
          ; skip to next primitive if intersection has been alread tested with current ray
          mov    bx,word [_cray  ]    ; current ray
          cmp    bx,word [edx+0Eh]    ; = last tested ray?
          je     near .next           ; then skip test
          mov    word [edx+0Eh],bx    ; else store current ray number
          ; dispatch intersector by primitive type
          mov    cx,word [edx]
          test   cx,0FFFEh        ; 0 or 1
          jnz    .cont1
          call   IntersectPara0
          jmp    .compar
.cont1:   cmp    cx,2
          jne    .cont2
          call   IntersectSimpleSphere0
          jmp    .compar
.cont2:   cmp    cx,4
          jne    .cont3
          call   IntersectCube0
          jmp    .compar
.cont3:   push   eax
          push   edx
          push   edx
          call   _RV_DispatchIntersectOther0
          add    esp,4
          pop    edx
          pop    eax
.compar:  movss  XMM5,[eax+50h]
          comiss XMM5,[fzero  ]
          jc     .next           
          movss  XMM6,[_Cmin+30h]
          comiss XMM6,[fzero  ]
          jc     .storHit
          comiss XMM5,XMM6
          jnc    .next
.storHit: mov    dword [eax+54h],edx
          mov    ecx,0Fh
          lea    esi, [eax+20h]
          mov    edi, _Cmin
      rep movsd
.next:    pop    ebx
          mov    ebx,[ebx+4]
          test   ebx,0FFFFFFFFh
          jnz    .loop

          pop    ecx
          pop    ebx
          pop    eax
          leave
          ret

_RV_SIMD_TrLst0:
          push   ebp
          mov    ebp,esp
          push   eax
          push   ebx
          push   ecx
          mov    ebx,[ebp+8]      ; parameter to function (primitive pointer)
          mov    eax,_RV_MData    ; pointer to camera and SIMD ray vectors
          and    eax,0FFFFFFF0h   ; align to 16 byte

          mov    edx,dword [_bckdrp ]
          mov    dword [eax+0E0h],edx
          mov    dword [eax+0E4h],edx
          mov    dword [eax+0E8h],edx
          mov    dword [eax+0ECh],edx

.loop:    mov    edx,[ebx]
          push   ebx
          ; dispatch intersector by primitive type
          mov    cx,word [edx]
          test   cx,0FFFEh        ; 0 or 1
          jnz    .cont1
          call   SIMD_Int_Para0
          jmp    .compar
.cont1:   cmp    cx,2
          jne    .cont2
          call   SIMD_Int_SSphere0
          jmp    .compar
.cont2:   ;cmp    cx,4
          ;jne    .cont3
          ;call   IntersectCube0
          ;jmp    .compar
.cont3:   ;push   eax
          ;push   edx
          ;push   edx
          ;call   _RV_DispatchIntersectOther0
          ;add    esp,4
          ;pop    edx
          ;pop    eax
          movss   XMM2,[fminus1]
          pshufd  XMM3,XMM2,0
          movaps  [eax+70h],XMM3
.compar:  movaps  XMM5,[eax+0D0h]
          movaps  XMM4,[eax+070h]
          ; CMin.t<0?
          movss   XMM6,[fzero   ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM5,6
          movmskps ebx,XMM7
          ; CInt.t<CMin.t?
          cmpps   XMM5,XMM4,6
          movmskps ecx,XMM5
          or      bx,cx
          ; CInt.t>0?
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM4,1
          movmskps ecx,XMM7
          and     bx,cx
          ; skip individual test if all 4 rays failed
          jz      near .next
          ; else test each ray individually
          test    bx,1
          jz      .nxt1
          mov     dword [eax+0E0h],edx
          mov     ecx,dword [eax+070h]
          mov     dword [eax+0D0h],ecx
          mov     ecx,dword [eax+080h]
          mov     dword [eax+0F0h],ecx
          mov     ecx,dword [eax+090h]
          mov     dword [eax+100h],ecx
          mov     ecx,dword [eax+0A0h]
          mov     dword [eax+110h],ecx
.nxt1:    test    bx,2
          jz      .nxt2
          mov     dword [eax+0E4h],edx
          mov     ecx,dword [eax+074h]
          mov     dword [eax+0D4h],ecx
          mov     ecx,dword [eax+084h]
          mov     dword [eax+0F4h],ecx
          mov     ecx,dword [eax+094h]
          mov     dword [eax+104h],ecx
          mov     ecx,dword [eax+0A4h]
          mov     dword [eax+114h],ecx
.nxt2:    test    bx,4
          jz      .nxt3
          mov     dword [eax+0E8h],edx
          mov     ecx,dword [eax+078h]
          mov     dword [eax+0D8h],ecx
          mov     ecx,dword [eax+088h]
          mov     dword [eax+0F8h],ecx
          mov     ecx,dword [eax+098h]
          mov     dword [eax+108h],ecx
          mov     ecx,dword [eax+0A8h]
          mov     dword [eax+118h],ecx
.nxt3:    test    bx,8
          jz      .next
          mov     dword [eax+0ECh],edx
          mov     ecx,dword [eax+07Ch]
          mov     dword [eax+0DCh],ecx
          mov     ecx,dword [eax+08Ch]
          mov     dword [eax+0FCh],ecx
          mov     ecx,dword [eax+09Ch]
          mov     dword [eax+10Ch],ecx
          mov     ecx,dword [eax+0ACh]
          mov     dword [eax+11Ch],ecx
.next:    pop     ebx
          mov     ebx,[ebx+4]
          test    ebx,0FFFFFFFFh
          jnz     .loop

          call    SimpleShade

          pop     ecx
          pop     ebx
          pop     eax
          leave
          ret

RV_SIMD_TrLstS:
          movss   XMM2,[fone   ]
          pshufd  XMM3,XMM2,0
          movaps  [eax+210h],XMM3
.loop:    mov    edx,[ebx]
          push   ebx
          ; skip to next primitive if primitive has CAST_NO_SHADOW flag
          mov    cx,word [edx+2]
          and    cx,400h
          jnz    near .next

          ; skip to next primitive if intersection has been alread tested with current ray
          ;mov    bx,word [_cray  ]    ; current ray
          ;cmp    bx,word [edx+0Eh]    ; = last tested ray?
          ;je     near .next           ; then skip test
          ;mov    word [edx+0Eh],bx    ; else store current ray number
          ; dispatch intersector by primitive type
          mov    cx,word [edx]
          test   cx,0FFFEh        ; 0 or 1
          jnz    .cont1
          call   SIMD_Int_ParaS
          jmp    .compar
.cont1:   cmp    cx,2
          jne    .cont2
          call   SIMD_Int_SSphereS
          jmp    .compar
.cont2:   ;cmp    cx,4
          ;jne    .cont3
          ;call   IntersectCube0
          ;jmp    .compar
.cont3:   ;push   eax
          ;push   edx
          ;push   edx
          ;call   _RV_DispatchIntersectOther0
          ;add    esp,4
          ;pop    edx
          ;pop    eax
          movss   XMM2,[fone   ]
          pshufd  XMM3,XMM2,0
          movaps  [eax+70h],XMM3
.compar:

          ; skip to next primitive if current primitive is origin of ray
          ; and t is very small (self shadowing)
          ;cmp    edx, [_OrgOb]
          ;jne    .other1
          ;comiss XMM5,[fsmall]
          ;jc     .next
.other1:  ; skip to next primitive if hit is behind target or intersected primitve is the light
          ;test   dword [eax+5Ch],0FFFFFFFFh
          ;jz     .other2
          ;movss  XMM6,[eax+5Ch]
          ;comiss XMM5,XMM6
          ;jnc    .next
          ;cmp    edx, [_CLtOb]
          ;je     .next

          ; check where current primitive is origin of ray to avoid self shadowing
          movss    XMM0,[fone ]
          movss    XMM7,[fzero]
          pshufd   XMM0,XMM0,0
          cmp      edx, [eax+0E4h]
          je       .w1
          movss    XMM0,XMM7
.w1:      pshufd   XMM0,XMM0,57
          cmp      edx, [eax+0E8h]
          je       .w2
          movss    XMM0,XMM7
.w2:      pshufd   XMM0,XMM0,57
          cmp      edx, [eax+0ECh]
          je       .w3
          movss    XMM0,XMM7
.w3:      pshufd   XMM0,XMM0,57
          cmp      edx, [eax+0E0h]
          je       .w4
          movss    XMM0,XMM7
.w4:      
          movaps  XMM5,[eax+210h]
          movaps  XMM6,[eax+070h]
          orps    XMM6,XMM0
          andps   XMM5,XMM6
          movaps  [eax+210h],XMM5
          ; all CMax.t>0?
          movss   XMM6,[fzero   ]
          pshufd  XMM7,XMM6,0
          cmpps   XMM7,XMM5,6
          movmskps ebx,XMM7
          cmp     bl,15
          je      .eext
.next:    pop     ebx
          mov     ebx,[ebx+4]
          test    ebx,0FFFFFFFFh
          jnz     .loop
          ret
.eext:    pop     ebx
          ret

_RV_TraceList1:
          push   ebp
          mov    ebp,esp
          push   eax
          push   ebx
          push   ecx
          mov    ebx,[ebp+8]      ; parameter to function (primitive pointer)
          mov    eax,_RV_Data     ; pointer to camera and ray vectors
          and    eax,0FFFFFFF0h   ; align to 16 byte

.loop:    mov    edx,[ebx]
          push   ebx
          ; skip to next primitive if ray is a shadow feeler
          ; and primitive has CAST_NO_SHADOW flag
          test   dword [eax+5Ch],0FFFFFFFFh
          jz     .cont0
          mov    cx,word [edx+2]
          and    cx,400h
          jnz    near .next
.cont0:   ; skip to next primitive if intersection has been alread tested with current ray
          mov    bx,word [_cray  ]    ; current ray
          cmp    bx,word [edx+0Eh]    ; = last tested ray?
          je     near .next           ; then skip test
          mov    word [edx+0Eh],bx    ; else store current ray number
          ; dispatch intersector by primitive type
          mov    cx,word [edx  ]
          test   cx,0FFFEh
          jnz    .cont1
          call   IntersectPara1
          jmp    .compar
.cont1:   cmp    cx,2
          jne    .cont2
          call   IntersectSimpleSphere1
          jmp    .compar
.cont2:   cmp    cx,4
          jne    .cont3
          call   IntersectCube1
          jmp    .compar
.cont3:   push   eax
          push   edx
          push   edx
          call   _RV_DispatchIntersectOther1
          add    esp,4
          pop    edx
          pop    eax
.compar:  ; skip to next primitive if t<0
          ; (no intersection or behind origin)
          movss  XMM5,[eax+50h]
          comiss XMM5,[fzero  ]
          jc     .next           
          ; skip to next primitive if current primitive is origin of ray
          ; and t is very small (self shadowing)
          cmp    edx, [_OrgOb]
          jne    .other1
          comiss XMM5,[fsmall]
          jc     .next
.other1:  ; skip to next primitive if ray is a shadow feeler and hit is behind target
          ;                                                  or  intersected primitve is the light
          test   dword [eax+5Ch],0FFFFFFFFh
          jz     .other2
          movss  XMM6,[eax+5Ch]
          comiss XMM5,XMM6
          jnc    .next
          cmp    edx, [_CLtOb]
          je     .next
.other2:  ; store intersection if it is the first
          movss  XMM6,[_Cmin+30h]
          comiss XMM6,[fzero  ]
          jc     .storHit
          ; skip to next primitive if previously stored intersection is nearer
          comiss XMM5,XMM6
          jnc    .next
.storHit: ; store intersection parameters
          mov    dword [eax+54h],edx
          mov    ecx,0Fh
          lea    esi, [eax+20h]
          mov    edi, _Cmin
      rep movsd
          ; exit after first hit if ray is a shadow feeler
          test   dword [eax+5Ch],0FFFFFFFFh
          jnz    .popexit
.next:    pop    ebx
          mov    ebx,[ebx+4]
          test   ebx,0FFFFFFFFh
          jnz    .loop

          pop    ecx
          pop    ebx
          pop    eax
          leave
          ret
.popexit: pop    ebx
          pop    ecx
          pop    ebx
          pop    eax
          leave
          ret
